aniOff	ld a,0x37
	ld (aniFlag),a
	ret
aniOn	ld a,0xa7
	ld (aniFlag),a
	ret

aniChar	ld a,scrBank0
	call bankSR
	ld ix,(npcTabAdr)
ach_Z	call ach_1
	ld ix,(elmTabAdr)
ach_1	ld a,(ix)
	inc a
	ret z
	ld a,(curMap)
	cp (ix+1)
	jr nz,achNXT
	ld a,(ix+7)	; anim.cnt
	sub 1
	jr c,achNXT
	ld (ix+7),a
	jr nz,achNXT
	ld l,(ix+8)	; anim.adr
	ld h,(ix+9)
	ld a,h
	or l
	jr z,achRET
achCYC	ld a,(hl)
	and a		; 00 : stop animation
	jr z,achRET
	inc hl
	cp 0xf0		; F0..FF : commands
	jr nc,achCMD
	ld (ix+7),a
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	push de
	call aniRMS
	pop hl		; new spr.adr
	ld (ix+5),l
	ld (ix+6),h
	call aniPTS
	pop hl
	and a
achRET	ld (ix+8),l
	ld (ix+9),h
	jr c,achCYC
achNXT	ld bc,chaDSCSize
	add ix,bc
	jr ach_1
achCMD	push hl
	ld hl,achRET
	ex (sp),hl
	push hl
	ld hl,aniCTab
	and 15
	add a,a
	ADDA h,l
	LDHL
	ex (sp),hl
	ret
	
aniRMS	ld c,(ix+2)
	ld b,(ix+3)
	ld d,(ix+4)
	ld l,(ix+5)
	ld h,(ix+6)
	call engine.rmSpr
updOn	ld a,0x37
	ld (updFlag),a
	ret

aniPTS	ld c,(ix+2)
	ld b,(ix+3)
	ld d,(ix+4)
	ld l,(ix+5)
	ld h,(ix+6)
	call engine.drawSpr
	jr updOn
	
aniCTab	dw aniF0,aniF1,aniF2,aniF3
	dw ani00,ani00,ani00,ani00
	dw ani00,ani00,ani00,ani00
	dw ani00,ani00,ani00,aniFF
	
	
; F0 - direction
aniF0	ld c,(hl)
	inc hl
	ld de,af0tab
	call jumpCDE
ani00	scf
	ret

af0tab	DBW 0,af000
	DBW 1,af001
	DBW 2,af002
	DBW 3,af003
	DBW 4,af004
	DBW 5,af005
	db 0xff

af000	ld a,(hl)	; f0,0,dir	move sprite to dir dir
	inc hl
	push hl
	push af
	call aniRMS
	pop af
	ld hl,af000t
	and 3
	call jumpTab
	call aniPTS
	pop hl
	scf
	ret

af000t	dw af0up,af0rg,af0dn,af0lf

af0up	dec (ix+3)
	ret
af0dn	inc (ix+3)
	ret
af0lf	dec (ix+2)
	ret
af0rg	inc (ix+2)
	ret

af001	ld a,(hl)	; f0,1,d	set dir=d
	ld (ix+10),a
	inc hl
	ret
	
af002	ld c,(hl)	; f0,2,d	go map dir d
	inc hl
	ld de,af002t
	push hl
	call jumpCDE
	pop hl
	scf
	ret
	
af002t	DBW dirNorth,af002n
	DBW dirEast,af002e
	DBW dirSouth,af002s
	DBW dirWest,af002w
	db 0xff
	
af002n	ld a,(upMap)
	jr af002a
af002s	ld a,(dnMap)
	jr af002a
af002w	ld a,(lfMap)
	jr af002a
af002e	ld a,(rgMap)
af002a	push af
	push de
	push ix
	call map.setMap
	pop ix
	pop de
	pop af
	ld (ix+1),a
	jp aniPTS

af003	ld a,(hl)		; f0,3,0	remove sprite
	inc hl			; f0,3,x	draw sprite
	push hl
	and a
	push af
	call nz,aniPTS
	pop af
	call z,aniRMS
	pop hl
	ret
	
af004	ld e,(hl)		; f0,4,x,y	change position
	inc hl			; x or y	128 : from fatkAP (victim)
	ld d,(hl)		;		129 : from fatkIP (attacker)
	inc hl			;		130 : middle of AP/IP
	push hl
	ld bc,(fatkIP)	; atk
	ld hl,(fatkAP)	; vic
	ld a,e
	call af004sr
	ld e,a
	ld c,b
	ld l,h
	ld a,d
	call af004sr
	ld d,a
af004a	push de
	call aniRMS
	pop de
	ld (ix+2),e
	ld (ix+3),d
	call aniPTS
	pop hl
	ret
	
af004sr	cp 0x80
	jr z,af04L
	cp 0x81
	jr z,af04C
	cp 0x82
	ret nz
	ld a,c
	add a,l
	rra
	ret
af04L	ld a,l
	ret
af04C	ld a,c
	ret

af005	ld a,(ix+2)		; f0,05,dx,dy	shift (x += dx, y += dy)
	add a,(hl)
	ld e,a
	inc hl
	ld a,(ix+3)
	add a,(hl)
	ld d,a
	inc hl
	push hl
	jr af004a

; F1 - bits work
; = 03 in script

aniF1	jp script.txt03

; F2 - misc

aniF2	ld c,(hl)
	inc hl
	ld de,af2tab
	jp jumpCDE

af2tab	DBW 0,af200
	DBW 1,af201
	DBW 2,af202
	db 0xff
	
af200	ld e,(hl)		; F2,00,<adr>	if door ahead, go through and jump <adr>
	inc hl
	ld d,(hl)
	inc hl
	push hl
	push de
	call checkDoor
	pop de
	pop hl
	scf
	ret z
	ex de,hl
	ret

af201	ld e,(hl)		; F2,01,<adr>	run script (animation will be paused)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	push ix
	ex de,hl
	call script.exec
	pop ix
	pop hl
	scf
	ret
	
af202	ld c,(hl)		; F2,02,id	play SFX id
	inc hl
	push hl
	call setSFX
	pop hl
	scf
	ret

; F3 - cycle

aniF3	ld c,(hl)
	inc hl
	ld de,af3tab
	jp jumpCDE
	
af3tab	DBW 0,af300
	DBW 1,af301
	db 0xff
	
af300	ld a,(hl)
	inc hl
	ld (ix+21),a
	ld (ix+22),l
	ld (ix+23),h
	scf
	ret
	
af301	dec (ix+21)
	scf
	ret z
	ld l,(ix+22)
	ld h,(ix+23)
	scf
	ret

; FF - conditions/jumps

aniFF	ld a,(hl)
	ld c,a
	inc hl
	inc a		; ff,ff,<adr>		jump adr (no condition)
	jr z,aff_1
	ld de,afftab
	call jumpCDE
	jr c,aff_1
	inc hl
	inc hl
	scf
	ret
aff_1	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	scf
	ret

afftab	DBW 0,aff00
	DBW 1,aff01
	DBW 2,aff02
	DBW 3,aff03
	DBW 4,aff04
	DBW 5,aff05
	DBW 6,aff06
	DBW 7,aff07
	DBW 8,aff08
	DBW 9,aff09
	db 0xff

; affXX return CY=1 when condition is true
	
aff00	ld a,(hl)	; ff,0,n,<adr>		if bit n = 0
	inc hl
	push hl
	call bitAdr
	ld a,(hl)
	and c
	pop hl
	ret nz
	scf
	ret
	
aff01	ld a,(hl)	; ff,1,n,<adr>		if bit n = 1
	inc hl
	push hl
	call bitAdr
	ld a,(hl)
	and c
	pop hl
	ret z
	scf
	ret
	
aff02	ld a,(ix+2)	; ff,2,n,<adr>		if pos.x = n
aff02a	ld c,(hl)
	inc hl
	cp c
	scf
	ret z
	and a
	ret

aff03	ld a,(ix+3)	; ff,3,n,<adr>		if pos.y = n
	jr aff02a

aff04	ld c,(hl)	; ff,4,dir,<adr>	if not possible to go dir
	inc hl
	ld de,aff04tab
	push hl
	call jumpCDE
	pop hl
	ret
	
aff04tab
	DBW dirNorth,aff04n
	DBW dirEast,aff04e
	DBW dirSouth,aff04s
	DBW dirWest,aff04w
	db 0xff
	
aff04n	ld c,(ix+2)
	ld b,(ix+3)
	ld e,(ix+5)
	ld d,(ix+6)
	inc de
	ld a,(de)
	add a,b
	sub 2
	ld b,a
aff04n0	sub 0		; ; will be set on tInitViewport
aff04n1	cp 24
	ret nc
	dec de
	ld a,(de)		; dX
	exa
	call engine.bc2scr	; above feets (check impassable blocks)
	exa
	ld b,a
aff04nz	call engine.checkHL
	ld a,(boxMask)
	and e
	scf
	ret nz
	inc l
	djnz aff04nz
	and a
	ret

aff04s	ld e,(ix+5)
	ld d,(ix+6)
	inc de
	ld a,(de)
	add a,(ix+3)
	ld b,a
	ld c,(ix+2)
	jr aff04n0

aff04w	ld c,(ix+2)
	dec c
	ld e,(ix+5)
	ld d,(ix+6)
aff04w0	inc de
	ld a,(de)
	add a,(ix+3)
	dec a
	ld b,a
	ld a,c
aff04m0	sub 0		; will be set on tInitViewport
aff04m1	cp 32
	ret nc
	call engine.checkXY
	ld a,(boxMask)
	and e
	ret z
	scf
	ret

aff04e	ld e,(ix+5)
	ld d,(ix+6)
	ld a,(de)
	add a,(ix+2)
	ld c,a
	jr aff04w0
	
aff05	ld a,(ix+10)	; ff,5,d,adr		if dir != d
	cp (hl)
	inc hl
	ret z
	scf
	ret
	
aff06	ld c,(hl)	; ff,6,d,adr		if no map @ dir d
	inc hl
	ld de,aff06t
	jp jumpCDE
	
aff06t	DBW dirNorth,aff06n
	DBW dirSouth,aff06s
	DBW dirWest,aff06w
	DBW dirEast,aff06e
	db 0xff
	
aff06n	ld a,(upMap)
	jr aff06a
aff06s	ld a,(dnMap)
	jr aff06a
aff06w	ld a,(lfMap)
	jr aff06a
aff06e	ld a,(rgMap)
aff06a	add a,1		; FF -> CY=1, !FF -> CY=0
	ret

aff07	ld c,(hl)	; ff,7,num,adr		if RND(255) < num
	inc hl
	call getRnd
	cp c		; C = true, NC = false
	ret

aff08	ld a,(hl)	; ff,8,n,m,adr		if (var n == m)
	inc hl
	call getVar
	cp (hl)
	inc hl
	scf
	ret z
	ccf
	ret
	
aff09	ld a,(hl)	; ff,9,n,m,adr		if (var n != m)
	inc hl
	call getVar
	cp (hl)
	inc hl
	ret z		; NC
	scf
	ret

; set animation DE to char A
setCAni	ld hl,(npcTabAdr)		; NPC
	jr scaENT
setEAni	ld hl,(elmTabAdr)		; map elements
scaENT	push de
	ld e,a
	ld bc,chaDSCSize
sca_1	ld a,(hl)
	cp 255
	jr z,sca_N
	cp e
	jr z,sca_Y
	add hl,bc
	jr sca_1
sca_N	pop de
	ret
sca_Y	pop de
	ld bc,7
	add hl,bc
;	ld a,(hl)
;	and a
;	ret nz
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	dec hl
	dec hl
	ld (hl),1
	scf
	ret

; set items,animations & chars on current map
	
setAll	ld hl,engine.drawSpr
	ld bc,engine.setTile
	jr rmset

; remove items,animations & chars from current map

rmAll	ld hl,engine.rmSpr
	ld bc,engine.rmTile
rmset	ld a,(curMap)
	cp 255
	ret z
	ld e,a
	ld (rmaSC+1),hl
	ld (rmaTC+1),bc
	call rmItems
	ld hl,(elmTabAdr)
	ld bc,actDSCSize-1
	call rma_sr
	ld hl,(npcTabAdr)
	ld bc,chaDSCSize-1
rma_sr	ld a,(hl)
	inc a
	ret z
	inc hl
	ld a,(hl)
	cp e
	jr nz,rma_4
	push bc
	push de
	push hl
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld d,(hl)
	inc hl
	LDHL
	ld a,h
	or l
rmaSC	call nz,engine.rmSpr
	pop hl
	pop de
	pop bc
rma_4	add hl,bc
	jr rma_sr

rmItems	ld hl,(itemTabAdr)
	ld bc,itemDSCSize-1
rma_1	ld a,(hl)
	inc a
	ret z
	inc hl
	ld a,(hl)
	cp e
	jr nz,rma_2
	push bc
	push de
	push hl
	inc hl
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld e,(hl)
	LDB d,(layMap+3)
rmaTC	call engine.rmTile
	pop hl
	pop de
	pop bc
rma_2	add hl,bc
	jr rma_1

