	MODULE battle

afCNT=4		; maximum affects on NPC

; execute battle C
; Z : battle not found
; NZ, C : lose
; NZ, NC : win

exec	ld hl,(batlTabAdr)
dfgtNZ	ld a,(hl)
	cp 0xff
	ret z
	inc hl
	cp c
	jr z,dfgtZ
	inc hl
	inc hl
	jr dfgtNZ
dfgtZ	LDHL		; HL : battle data addr

	call ldDE	; 0 : battle script adr
	push de
	call ldDE	; 2 : start script (0:none)
	ld (startScriptAdr),de
	call ldDE	; 4 : lose script (0:none)
	ld (loseScriptAdr),de
	call ldDE	; 6 : win script (0:none)
	ld (winScriptAdr),de

	ld iy,bdatTab
	xor a		; init Hero
dfgt1	exa
	ld a,(hl)	; NPCid
	ld (iy),a
	cp 255
	jr z,dfgt3
	inc hl
	call ldBC	; x,y
	call ldDE	; dsc.adr
	ld a,c
	inc a
	call z,dfgtPos
	ld a,(hl)	; flag
	inc hl
dfgt1a	push hl
	push iy
	call fgtInitChar
	pop iy
	pop hl
	jr nc,dfgt1b
	ld de,bdatSize
	add iy,de
dfgt1b	exa
	inc a
	cp 8			; max 8 fighters (hero + 7 enemies)
	jr c,dfgt1
dfgt3	ld (iy),0xff
	inc iy
	ld (fbSpace),iy
	pop hl
	call script.runScript	; run battle script
	; call potion.reset	; reset all potion affects
	call updOn
	or 2		; NZ
brFlag	and a		; scf/and a = C/NC = lose/win
	ret

dfgtPos	push de
	ld c,(iy)
	call findNPC
	ld c,(ix+2)
	ld b,(ix+3)
	pop de
	ret

fDelHM	ld ix,fWins		; remove info window
	ld hl,engine.rmSpr
	call dfgt3S
dfgt3S	ld (dfgt3p+1),hl
dfgt3a	ld c,(ix)
	ld a,c
	inc a
	ret z
	ld b,(ix+1)
	ld a,(vpPos)
	add a,c
	ld c,a
	ld a,(vpPos+1)
	add a,b
	ld b,a
	ld l,(ix+2)
	ld h,(ix+3)
	LDB d,(layMap+7)
dfgt3p	call engine.drawSpr
	ld de,4
	add ix,de
	jr dfgt3a
	
fWins	dw 0x0F12,win93
	db 0xff
	
win93	db 12,4
	db 1,2,2,2,2,2,2,2,2,2,2,3
	db 4,5,5,5,5,5,5,5,5,5,5,6
	db 4,5,5,5,5,5,5,5,5,5,5,6
	db 7,8,8,8,8,8,8,8,8,8,8,9

; init battle npc to iy
; a : flag
; c,b : x,y
; de : dsc.adr
fgtInitChar
	ld (flgPOK+1),a
	push bc
	push de
	ld c,(iy)
	call findNPC	; ix = npc dsc from charTab
	pop de
	pop bc
	ret nc
	ld a,(curMap)
	ld (ix+1),a	; map
	ld (ix+2),c	; x
	ld (ix+3),b	; y
	ex de,hl
	ld d,hy
	ld e,ly
	ld a,(de)
	inc de
	and a
	jr nz,finc1
	ld hl,heroData
	call finc1
	ld b,0
	ld a,fxSTART			; activate start amulet
	call applyAffect
	scf
	ret
finc1	ldi	; anim.tab.adr
	ldi
	ld a,(ix+24)	; HP = maxHP
	ld (de),a
	inc de
	ld (de),a
	inc de
	ld a,(ix+25)	; MP = maxMP
	ld (de),a
	inc de
	ld (de),a
	inc de
	ex de,hl	; atk/def tab adr
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
flgPOK	ld (hl),0	; flag
	inc hl
	ld bc,0x0800
finc2	ld (hl),c
	inc hl
	djnz finc2
	ex de,hl
	ld a,0xff
	ld (de),a
	ld c,(iy)
	ld a,0xff
	call setXNPC
	ld a,bsIDL
	call runScript
	scf
	ret

; check battle win
; out : NC : enemy still alive
;	C  : all agressive enemies is dead
fchkWin	push ix
	ld ix,bdatTab
	ld de,bdatSize
	ld c,0
fcwin1	ld a,(ix)
	inc a
	jr z,fcwinE
	ld a,(ix+9)	; b0:passive, b1:ally
	and 3
	jr nz,fcwin2
	ld a,(ix+3)	; hp
	or c
	ld c,a
fcwin2	add ix,de
	jr fcwin1
fcwinE	pop ix
	ld a,c
	and a
	ret nz
	scf
	ret

; check battle lose
; out : NC : at least 1 ally is alive
;	C : all allies is dead
fchkLos	push ix
	ld ix,bdatTab
	ld de,bdatSize
	ld c,0
fclos1	ld a,(ix)
	inc a
	jr z,fclosE
	bit 1,(ix+9)	; Z:enemy
	jr z,fclos2
	ld a,(ix+3)
	or c
	ld c,a
fclos2	add ix,de
	jr fclos1
fclosE	pop ix
	ld a,c
	and a
	ret nz
	scf
	ret
	
; make a turn: dec all effects duration, exec fxTURN effects
turn	ld a,fxTURN
	call equip.afAmulet
	ld hl,bdatTab
btrn1	ld a,(hl)
	inc a
	ret z
	push hl
	ld de,10
	add hl,de
	push hl		; exec fxTURN effects
	ld b,fxTURN
	call exef0
	pop hl
	ld b,afCNT	; dec all effects duration
btrn2	ld a,(hl)
	inc a
	jr z,btrn3
	sub 2
	jr c,btrn3
	ld (hl),a
btrn3	inc hl
	inc hl
	djnz btrn2
	pop hl
	ld de,bdatSize
	add hl,de
	jr btrn1
;btrn4	ld a,fxTURN
;	jp applyAffect

; HL = dsc.adr of battle NPC id:C;
;	0xf8..0xff = special
findBNPC
	ld a,c
	cp 0xf8
	call nc,getXNPC
fbnpc00	ld hl,bdatTab
	ld de,bdatSize
fbnpc01	ld a,(hl)
	cp c
	ret z
	inc a
	scf
	ret z
	add hl,de
	jr fbnpc01

getBNPC	push hl
	call findBNPC
	ex (sp),hl
	pop iy
	ret
	
getXNPC	and 7
	ld hl,xNPCTab
	ADDA h,l
	ld a,(hl)
	ld c,a
	ret
	
setXNPC	and 7
	ld hl,xNPCTab
	ADDA h,l
	ld (hl),c
	ret

xNPCTab	db 0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff	; F8..FF special BNPC id

; iy = bdsc of random live enemy (rnd of 7)
pickAlly			; random ally
	ld a,0x28		; jr z
	jr penmIN
pickEnemy			; random enemy
	ld a,0x20		; jr nz
penmIN	ld (ePok1),a
	call getRnd
	and 7
	inc a
	ld bc,bdatSize
	exa
eatk1	ld iy,bdatTab
eatk2	ld a,(iy)	; not hero
	;and a
	;jr z,eatk3
	inc a
	jr z,eatk1
	ld a,(iy+3)	; have HP
	and a
	jr z,eatk3
	bit 1,(iy+9)	; right type
ePok1	jr nz,eatk3
	bit 0,(iy+9)	; not passive
	jr nz,eatk3
	exa
	dec a
	jr z,eatkY
	exa
eatk3	add iy,bc
	jr eatk2
eatkY	ld c,(iy)
	jp findNPC
	
; C = damage of atack npc (B,DE) to npc (C,HL)	(B,C:id; DE,HL:atack param adrs)
	display $
getDamage
	push bc
	inc hl
	ld bc,defBuf
	call gdPut4
	ex de,hl
	ld bc,atkBuf
	call gdPut4
	pop bc
	push bc
; TODO: fxATK0 @ B, fxDEF0 @ C
	ld a,fxATK0	; 1:change ATK/DEF by pre-affects
	call applyAffect
	ld b,c
	ld a,fxDEF0
	call applyAffect
; OLD
;	ld a,b		; if ATK is hero, add pre-attack affects
;	and a
;	ld a,fxATK0
;	call z,applyAffect
;	ld a,c		; if DEF is hero, add pre-defence affects
;	and a
;	ld a,fxDEF0
;	call z,applyAffect
; END
	ld de,atkBuf	; 2:calculate damage
	ld hl,defBuf
	ld bc,0x0400
cdmg0	ld a,(hl)	; def %
	exa
	ld a,(de)	; atk
	exx
	ld d,a		; D = atk
	exa
	ld e,a		; E = def %
	call multDE	; D = atk * def / 256 = damage reduction
	exa
	sub d		; A = atk - reduction;
	exx
cdmgA	add a,c
	jr nc,cdmgB
	ld a,0xff
cdmgB	ld c,a
	inc de
	inc hl
	djnz cdmg0
	ld a,c
	ld (bDamage),a
	pop bc
; TODO: fxATK1 @ B, fxDEF1 @ C
	ld a,fxATK1	; 3:change damage by post-affects
	call applyAffect
	ld b,c
	ld a,fxDEF1
; OLD
;	ld a,b
;	and a
;	ld a,fxATK1
;	call z,applyAffect
;	ld a,c
;	and a
;	ret nz
;	ld a,fxDEF1
; END
applyAffect			; apply affects of type A to npc B
	push bc
	push af
	inc b
	dec b
	call z,equip.afAmulet	; amulet affects NPC 0 only ?
	pop af
	pop bc
	push bc
	call battle.exeEffect
	pop bc
	ret
	
	display "addEffect = ",$
addEffect		; apply effect B to npc C
	call findBNPC
	ret c
	ld de,10
	add hl,de
	push hl
	ld c,b
	call effect.find
	ld c,(hl)	; id
	inc hl
	inc hl
	ld d,(hl)	; duration
	pop hl
	ret c
	ld b,afCNT
adef1	ld a,(hl)
	and a
	jr z,adef2
	inc hl
	inc hl
	djnz adef1
	scf
	ret
adef2	ld (hl),d
	inc hl
	ld (hl),c
	and a
	ret
	
; apply all effects of type A to NPC B
exeEffect
	ld c,b
	ld b,a
	ld a,0xff		; BNPC[255]=npcId
	call setXNPC
	call findBNPC
	ret c
	ld de,10
	add hl,de		; hl = affects tab
exef0	ld a,afCNT
exef1	push af
	ld a,(hl)		; duration (0:not active)
	and a
	jr nz,exef2
	inc hl
exef1a	inc hl
	pop af
	dec a
	jr nz,exef1
	ret
exef2	inc hl			; find effect dsc
	ld c,(hl)
	push hl
	call effect.find
	jr c,exef3
	inc hl
	ld a,(hl)		; check type
	cp b
	jr nz,exef3
	inc hl
	inc hl
	push bc
	LDHL
	or l
	call nz,script.exec	; exec affect script
	pop bc
exef3	pop hl
	jr exef1a

gdPut4	ld a,4
gdp4	exa
	ld a,(hl)
	ld (bc),a
	inc hl
	inc hl
	inc bc
	exa
	dec a
	jr nz,gdp4
	ret
	
atkBuf	ds 4			; attacker ATK
defBuf	ds 4			; victim DEF

; show number B above npc C, duration = 2 sec
showDamage
	push bc
	ld a,b
	ld hl,numBuf
	call putNum
	pop bc
	call findNPC
	ld c,(ix+2)
	ld b,(ix+3)
	dec b
	ld hl,numSpr
	LDB d,(layMap+7)
	push bc
	call engine.drawSpr
	call updOn
	ld b,100
cdmg3	halt
	push bc
	call aniSR
	pop bc
	djnz cdmg3
	pop bc
	ld hl,numSpr
	LDB d,(layMap+7)
	call engine.rmSpr
	jp updOn

numSpr	db 3,1
numBuf	db "000"

; runScript : run script id:A to enemy id:C

runScript
	push af
	call getBNPC	; find npc C
;	ld c,(iy)
	call findNPC
	pop af
	ld l,(iy+1)	; table adr
	ld h,(iy+2)
	ld c,a
rixs01	ld a,(hl)
	cp 0xff
	ret z
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	cp c
	jr nz,rixs01
	ex de,hl
	jp script.exec

; select ally
selAlly	ld iy,bdatTab
	ld de,bdatSize
	ld hl,0
	ld c,0
sal01	ld a,(iy)
	inc a
	jr z,sal03
	ld a,(iy+3)
	and a
	jr z,sal02
	bit 1,(iy+9)
	jr z,sal02
	push iy
	pop hl
	inc c
sal02	add iy,de
	jr sal01
sal03	ld a,c
	and a			; error : no allies ?
	call z,L7Error
	dec a			; single ally : HL = dsc
	ld a,0x28		; jr z
	ld c,0xc9		; ret
	jr nz,stargIN		; NZ:not single (select it), IY = dsc
	push hl
	pop iy
	ret

; ---------------
; select enemy for atack
; out:	 C - canceled
;	NC - selected, IY = bdatTab.adr, IX = charTab.adr

selTarget
	ld a,0x20
	ld c,0x00
stargIN	ld (zPok1),a
	ld (zPok2),a
	ld a,c
	ld (stkK0),a
	ld iy,bdatTab
	call stkP
starg1	halt
	call aniSR
	ld hl,stKTab
	call inKeys
	jr starg1
	
stKTab	dw 0x01df,stkP		; P
	dw 0x02df,stkO		; O
	dw 0x10ef,stkO		; 6
	dw 0x08ef,stkP		; 7
	dw 0x017f,stkSp		; Space
	dw 0x01ef,stkSp		; 0
	dw 0x01bf,stkK0		; Enter (cancel)
	db 0

stkK0	nop			; cancel (00/C9 = open/close)
	call stArrZ
	call noKey
	pop af
	scf
	ret
	
stkSp	call stArrZ		; space,0 : select
	call noKey
	ld c,(iy)
	call findNPC
	pop af
	and a
	ret
	
stkP	call stArr0		; P : next enemy
	ld de,bdatSize
stkp1	add iy,de
	ld a,(iy)	; last : go to start of table
	inc a
	jr nz,stkp2
	ld iy,bdatTab
stkp2	bit 1,(iy+9)	; Z:enemy
zPok1	jr nz,stkp1
	ld a,(iy+3)	; have HP
	and a
	jr z,stkp1
stkpE	call stArr1
	jp noKey

stkO	call stArr0		; O : prev enemy
stko1	ld de,-bdatSize
	add iy,de
	ld e,ly
	ld d,hy
	ld hl,bdatTab
	and a
	sbc hl,de
	ld a,h
	or l
	jr nz,stko3
	ld de,bdatSize
stko2	add iy,de
	ld a,(iy + bdatSize)
	inc a
	jr nz,stko2
stko3	bit 1,(iy+9)
zPok2	jr nz,stko1
	ld a,(iy+3)
	and a
	jr z,stko1
	jr stkpE
	
stArr1	ld c,(iy)		; draw arrow
	call findNPC
	ld c,(ix+2)
	ld b,(ix+3)
	dec b
	LDB d,(layMap+6)
	ld e,16
	call engine.setTile
	ld a,(iy+3)
	ld hl,ehpChp
	call putNum
	ld a,(iy+4)
	ld hl,ehpMhp
	call putNum
	ld bc,0x1301
	ld hl,ehpInfo
	ld d,7
	call engine.drawSpr
	jp updOn
	
stArrZ	ld bc,0x1301
	ld hl,ehpInfo
	ld d,7
	call engine.rmSpr
stArr0	ld c,(iy)		; remove arrow
	call findNPC
	ld c,(ix+2)
	ld b,(ix+3)
	dec b
	LDB d,(layMap+6)
	call engine.rmTile
	jp updOn

ehpInfo	db 9,1,32
ehpChp	db "000/"
ehpMhp	db "000 "

; ---------------
; draw Hero HP/MP
fShowHM	ld ix,fWins		; draw info window
	ld hl,engine.drawSpr
	call dfgt3S
	call fHeroHM
fHeroHM	ld c,0			; draw info text
	call getBNPC
	ld a,(iy+3)
	ld hl,fchpbuf
	call putNum
	ld a,(iy+4)
	ld hl,fmhpbuf
	call putNum
	ld hl,"PH"
	ld (ftxtHP),hl
	ld bc,0x1114
	ld hl,ftxtSPR
	LDB d,(layMap+7)
	call engine.drawSpr
	ld a,(iy+5)
	ld hl,fchpbuf
	call putNum
	ld a,(iy+6)
	ld hl,fmhpbuf
	call putNum
	ld hl,"PM"
	ld (ftxtHP),hl
	ld bc,0x1214
	ld hl,ftxtSPR
	LDB d,(layMap+7)
	call engine.drawSpr
	jp updOn

ftxtSPR	db 10,1
ftxtHP	db "HP "
fchpbuf	db "000/"
fmhpbuf	db "000",0

; ---------------

startScriptAdr
	dw 0
winScriptAdr
	dw 0
loseScriptAdr
	dw 0

fgtECnt	db 0		; enemies count
bFlag	db 0

bDamage	db 0

bdatSize=2*afCNT + 10
bdatTab equ mapBuf
; +0	NPCid,<anims.adr>,hp,maxhp,mp,maxmp
; +7,8	atk/def tab.adr
; +9	flag		b0 : passive, can't attack;
;			b1 : ally
; +10	4x{duration,id} - affects

	ENDMODULE