	MODULE equip

exec	ld hl,eqmData
exCYC	ld a,(hl)
	inc a
	jr z,exRUN
	inc hl
	ld a,(hl)	; data = place.id
	inc hl
	inc hl
	inc hl
	push hl
	call getDSC	; DE = DSC of armor place.id
	ld hl,4
	add hl,de
	ld e,(hl)	; DE = Name.adr of armor place.id
	inc hl
	ld d,(hl)
	pop hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	jr exCYC
exRUN	ld hl,eqCls
	ld bc,0x0101
	ld d,7
	call engine.rmSpr
	ld hl,eqMenu
	ld bc,0x0101
	ld de,0
	ld a,3
	jp menu.exec
	
eqBack	call menu.mClose
	jp wBack
	
eqMenu	mText mmEHd
	mPunkt 0,mmBack,0,eqBack
eqmData	mPunkt 0,0,eArmor,chEquip	; text addrs is filled automaticly at start of equip.exec
	mPunkt 0,0,eSword,chEquip
	mPunkt 0,0,eShield,chEquip
	mPunkt 0,0,eAmulet,chEquip
	db 0xff

mmEHd	db 16,17," EQUIPMENT",0
eqCls	db 30,19

chEquip	ld a,c
	ld (eType),a
	ld hl,(eqpTabAdr)
	call findCHL
	ret c
	LDHL
	inc hl
	ld a,(hl)	; C = bits, b0 is allways set
	or 1
	ld c,a
	inc hl
	ex de,hl	; DE = DSC addrs tab
	ld hl,eqSMDat
	ld b,8
cheqCY2	rr c
	ccf
	sbc a,a
	and 0xfd
	ld (hl),a	; condition : 0 if bit set, FD if bit reset (show/don't show)
	inc hl	; condition
	inc hl	; data
	inc hl	; exec.adr
	inc hl
	push de
	ex de,hl
	ld a,(hl)
	inc hl
	ld h,(hl)
	add a,4
	ld l,a
	adc a,h
	sub l
	ld h,a
	LDHL
	ex de,hl	; de = equip name
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	pop de
	inc de
	inc de
	djnz cheqCY2
	ld hl,eqSubMenu
eqMRun	ld a,(menu.wCPos)
	add a,4
	ld b,a
	ld c,3
	ld a,3
	ld de,eqShowInfo
	jp menu.exec

eType	db 0

eqShowInfo
	ld a,c
	inc a
	jr z,eqsiOff
	ld b,c
	LDB c,(eType)
	call findEquip
	jr c,eqsiOff
	ld hl,6
	add hl,de
	LDHL
	ld a,h
	and a
	jr nz,eqsiT
	ld a,l
	dec a
	jr z,eqsi1
	dec a
	jr z,eqsi2
eqsiOff	ld hl,eqsiSpr		; off
	ld d,7
	ld bc,0x1301
	call engine.rmSpr
	jp reFresh
eqsi2	ld hl,eqsis01		; 2 show %
	call eqNumA
	ld hl,eqsis02
	call eqNumA
	ld hl,eqsis03
	call eqNumA
	ld hl,eqsis04
	call eqNumA
	jr eqsisw1
eqsi1	ld hl,eqsis01		; 1 show ABS
	call eqNum
	ld hl,eqsis02
	call eqNum
	ld hl,eqsis03
	call eqNum
	ld hl,eqsis04
	call eqNum
	jr eqsisw1
eqsiT	ex de,hl		; copy text DE
	ld hl,eqstSpr+2
	ld bc,0x1e20
eqst1	ld (hl),c
	inc hl
	djnz eqst1
	ld hl,eqstSpr+2
	ld b,30
eqst2	ld a,(de)
	cp 32
	jr c,eqst3
	cp 128
	jr c,eqst2a
	xor 64
eqst2a	ld (hl),a
	inc hl
	inc de
	djnz eqst2
eqst3	ld hl,eqstSpr
	jr eqsisw2
eqsisw1	ld hl,eqsiSpr
eqsisw2	ld d,7
	ld bc,0x1301
	call engine.drawSpr
	jp reFresh

eqNum	ld a,(de)
	inc de
	jp putNum
	
eqNumA	ld a,(de)
	inc de
	push de
	push hl
	ld e,a
	ld d,100
	call multDE
	ld a,d
	pop hl
	pop de
	jp putNum

eqstSpr	db 30,1
	ds 30
	
eqsiSpr	db 30,1," ",16,":"	; 3
eqsis01	db "000 ",18,":"	; 9
eqsis02	db "000 ",19,":"	; 15
eqsis03	db "000 ",20,":"	; 21
eqsis04	db "000"	; 23
	ds 7,32	; 30

eqSubMenu
	mPunkt 0,mmBack,0xff,exec
eqSMDat	mPunkt 0,0,0,chArmor
	mPunkt 0,0,1,chArmor
	mPunkt 0,0,2,chArmor
	mPunkt 0,0,3,chArmor
	mPunkt 0,0,4,chArmor
	mPunkt 0,0,5,chArmor
	mPunkt 0,0,6,chArmor
	mPunkt 0,0,7,chArmor
	db 0xff

chArmor	ld b,c
	LDB c,(eType)
	call setEquip
	call calcEquip
	jp exec

; C = equip type
; B = nr
; set equip (C,B) available
add	call getEBit
	ret c
	ld a,(hl)
	or c
	jr eqdel01

; set equip (C,B) not available
del	call getEBit
	ret c
	ld a,c
	cpl
	and (hl)
eqdel01	or 1
	ld (hl),a
	ret

; init all equipment (current = 0, disable all others)
reset	ld hl,(eqpTabAdr)
res01	ld a,(hl)
	inc a
	jp z,calcEquip
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	xor a
	ld (de),a
	inc de
	inc a
	ld (de),a
	jr res01

getEBit	ld hl,(eqpTabAdr)
	call findCHL
	ret c
	LDHL
	inc hl		; hl = equip availability bits byte
	ld a,b
	and 7
	ld c,0x01	; c = mask
	ret z
gebi01	rlc c
	dec a
	jr nz,gebi01
	and a
	ret

; C = equip type (eHead, eBody, ...)
; B = equip nr (0..7)
; return : HL = adr of params buffer (copy where you need to)
setEquip
	ld hl,(eqpTabAdr)
	call findCHL
	jr c,calcEquip
	LDHL
	ld a,b
	and 7
	ld (hl),a
; recalculate equip atack / defence parameters
calcEquip
	ld hl,eqPower
	ld bc,0x0800
ceq1	ld (hl),c
	inc hl
	djnz ceq1
	ld a,eShield
	call getDSC
	push de
	ld a,eArmor
	call getDSC
	pop bc		; bc : shield DSC; de : armor DSC
	ld a,4
	ld hl,eqPower+1
ceq2	exa

	IF 1		; new/old defence calculation

	ld a,(bc)
	exx
	ld c,a		; damage % reducted by shield
	cpl
	ld e,a		; and NOT reducted (255 - val)
	exx
	ld a,(de)
	exx
	ld d,a		; damage % reducted by armor
	call multDE	; D = damage % reduced by armor after NOT reduced by shield
	ld a,d
	add a,c		; shield reduction + armor reduction of not reducted
	exx
	
	ELSE
	
	ld a,(bc)
	ex de,hl
	add a,(hl)
	ex de,hl
	jr nc,ceq2a
	sbc a,a
ceq2a	
	
	ENDIF
	
	ld (hl),a
	inc hl
	inc hl
	inc bc
	inc de
	exa
	dec a
	jr nz,ceq2
	ld a,eSword	; sword force : just copy values
	call getDSC
	ld hl,eqPower
	ld b,4
ceq3	ld a,(de)
	ld (hl),a
	inc de
	inc hl
	inc hl
	djnz ceq3
	ld hl,eqPower
	ld de,eqHero
	ld bc,8
	ldir
	ret

eqPower	ds 8		; 4 x (atk, def)

; affect current amulet, if its type is A
afAmulet
	push af
	ld a,eAmulet
	call getDSC
	ex de,hl
	pop af
	cp (hl)
	ret nz
	inc hl
	inc hl
	LDHL
	jp script.exec

; DE = adr of dsc of equip B of type C
findEquip
	ld de,empString
	ld hl,(eqpTabAdr)
	call findCHL
	ret c
	LDHL
	ld a,b
	jr gdsc01
	
; DE = adr of dsc of current equip of type A
getDSC	ld de,empString
	ld hl,(eqpTabAdr)
	ld c,a
	call findCHL
	ret c
	LDHL
	ld a,(hl)
gdsc01	and 7
	inc hl
	inc hl
	add a,a
	ADDA h,l
	LD e,(hl)
	inc hl
	ld d,(hl)
	and a
	ret
	
findCHL	ld a,(hl)
	cp 0xff
	scf
	ret z
	inc hl
	cp c
	ret z
	inc hl
	inc hl
	jr findCHL
	

empString db 0

	ENDMODULE