; init all vars,bits,sbits,NPC,Elements,zones

initGame
	call wBank
	call aniOff
	
	ld hl,bitsTab	; bits
	ld bc,0x2000
	call fillMem
	
	ld hl,varsTab	; vars
	call fillMem	; b = 0
	
	call equip.reset
	
	call magic.reset
	ld c,0
	call magic.enable
	
	ld ix,(npcTabAdr)
	call initNPC
	ld ix,(elmTabAdr)
	call initNPC
	
	call initZones
	call initDoors
	call initItems
	
	ld hl,hpInit
	ld de,maxHP
	ldi
	ldi

	xor a
	ld h,a
	ld l,a
	ld (expa),hl
	ld (level),a

	ld a,7
	ld (engine.bgColor),a

	call engine.cls
	call equip.calcEquip
	
;	ld hl,0x0112		; debug !
;	ld (hItems),hl

	ret

; init doors, zone : copy b1,(+1) to b0,(+1)
initDoors
	ld hl,(doorTabAdr)
	ld de,doorDSCSize-1
	jr izon1

initZones
	ld hl,(zoneTabAdr)
	ld de,zoneDSCSize-1
izon1	ld a,(hl)
	inc a
	ret z
	inc hl
	ld a,(hl)	; copy b1 (init) to b0 (current)
	and 2
	jr z,izon2
	or 1
izon2	ld (hl),a
	add hl,de
	jr izon1	
	
initItems
	ld a,0xff
	ld (curItem),a
	ld ix,(itemTabAdr)
	ld de,itemDSCSize
initm1	ld a,(ix)
	inc a
	ret z
	LDB (ix+1),(ix+7)	; map,x,y
	LDB (ix+2),(ix+8)
	LDB (ix+3),(ix+9)
	ld (ix+10),1		; count
	ld (ix+13),0		; not in bag
	add ix,de
	jr initm1
	
initNPC	ld de,chaDSCSize
inpc1	ld a,(ix)
	inc a
	ret z
	LDB (ix+1),(ix+12)	; map
	LDB (ix+2),(ix+13)	; x
	LDB (ix+3),(ix+14)	; y
	LDB (ix+5),(ix+15)	; spr.adr
	LDB (ix+6),(ix+16)
	LDB (ix+10),(ix+19)	; affect.adr (elems)
	LDB (ix+11),(ix+20)
	LDB (ix+24),(ix+26)
	LDB (ix+25),(ix+27)
	ld c,(ix+17)
	ld b,(ix+18)
	ld a,b
	or c
	jr z,inpc2
	ld a,1
inpc2	ld (ix+7),a
	ld (ix+8),c
	ld (ix+9),b
	add ix,de
	jr inpc1

fillMem	ld (hl),c
	inc hl
	djnz fillMem
	ret
