iCount = 7

; B,C = items id under hero feet of NPC 0 (hero)
; FFFF : no items
getItemsUnder
	ld bc,itemDSCSize
	exx
	ld c,0
	call findNPC
	ret nc
	ld l,(ix + 5)
	ld h,(ix + 6)
	ld e,(ix + 2)
	ld d,(ix + 3)
	inc hl
	ld a,(hl)
	add a,d
	dec a
	ld d,a
	dec hl
	ld l,(hl)	; l:dX, DE:YX
	ld bc,0xffff	; bc: result
	ld ix,(itemTabAdr)
gitm1	ld a,(ix)
	inc a
	ret z
	ld a,(curMap)
	cp (ix+1)
	jr nz,gitmNXT
	ld a,(ix+3)
	cp d
	jr nz,gitmNXT
	ld a,(ix+2)
	sub e
	cp l
	jr nc,gitmNXT
	ld b,c
	ld c,(ix)
gitmNXT	exx
	add ix,bc
	exx
	jr gitm1

getCurItem
	ld a,(bagPos)
	inc a
	ld c,a
	ld ix,(itemTabAdr)
	ld de,itemDSCSize
gcit01	ld a,(ix)
	cp 0xff
	ret z
	bit 0,(ix+13)
	jr z,gcit02
	dec c
	jr z,gcit03
gcit02	add ix,de
	jr gcit01
gcit03	ld a,(ix)
	ret

; IX = DSC of item with id=C
; CY=1 : not found
findItem
	ld ix,(itemTabAdr)
	ld de,itemDSCSize
fitm1	ld a,(ix)
	cp 0xff
	scf
	ret z
	cp c
	ret z
	add ix,de
	jr fitm1

; set bagPos to item id=C (must be in bag)
updBagPos
	ld ix,(itemTabAdr)
	ld de,itemDSCSize
	ld b,0
ubp01	ld a,(ix)
	cp 0xff
	ret z
	bit 0,(ix+13)
	jr z,ubp02
	cp c
	jr z,ubp03
	inc b
ubp02	add ix,de
	jr ubp01
ubp03	ld a,b
	ld (bagPos),a
	ret

; build items table @ fbSpace
setList	ld ix,(itemTabAdr)
	ld de,itemDSCSize
	ld hl,(fbSpace)
	ld b,3
	call slst01
	ld hl,(fbSpace)
	ld bc,6
	add hl,bc
slst02	ld a,(ix)
	inc a
	jr z,slst04
	bit 0,(ix+13)
	jr z,slst03
	LDB (hl),(ix)
	inc hl
	LDB (hl),(ix+10)
	inc hl
slst03	add ix,de
	jr slst02
slst04	ld b,iCount
slst01	ld (hl),0xff
	inc hl
	ld (hl),0x00
	inc hl
	djnz slst01
	ret

; draw items from bag
drawBag
	call setList
	call getCurItem
	ld (curItem),a
dbag0	ld hl,(fbSpace)
	LDB e,(bagPos)
	ld d,0
	add hl,de
	add hl,de
	ex de,hl
	ld hl,bgAdrs
	ld b,iCount
dbag1	push hl
	LDHL		; HL = scr.adr
	push bc
	push de
	push hl
	ld a,(de)
	call drawItem
	pop hl
	pop de
	inc de
	push de
	ld a,l
	add a,64
	ld l,a
	sbc a,a
	and 8
	add a,h
	ld h,a
	ld a,(de)
	call itmNum
	pop de
	pop bc
	pop hl
	inc hl
	inc hl
	inc de
	djnz dbag1
	ret

itmNum	ex de,hl
	ld hl,0x2020
	ld (itmNBuf+1),hl
	ld hl,itmNBuf
	and a
	call nz,putNum
	ld a,(itmNBuf+1)
	call inumD
	inc e
	ld a,(itmNBuf+2)
inumD	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	add hl,hl
	ld bc,tile700 - 8
	add hl,bc
	ld c,d
	ld b,8
inum01	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	djnz inum01
	ld d,c
	ret

itmNBuf	ds 3

drawIcon
	ld de,empItem
	cp 0xff
	jr z,ditm0
	push hl
	ld l,a
	ld h,0
	add hl,hl
	add hl,hl
	ld e,l
	ld d,h
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld de,itemBIG
	add hl,de
	ex de,hl
	pop hl
	jr ditm0
drawItem
	ld c,a
	call findItem
	ld de,empItem
	jr c,ditm0
	ld e,(ix+5)
	ld d,(ix+6)
ditm0	ld a,gfxBank
	call bankSR
ditm1	push hl
	ld b,2
ditm2	ld a,(de)
	ld (hl),a
	inc de
	inc l
	ld a,(de)
	ld (hl),a
	inc de
	dec l
	inc h
	ld a,h
	and 7
	jr nz,ditm2
	ld a,l
	add a,32
	ld l,a
	jr c,ditm3
	ld a,h
	sub 8
	ld h,a
ditm3	djnz ditm2
	pop hl
	ld a,h
	rra
	rra
	rra
	and 3
	or 0x58
	ld h,a
	ld bc,31
	ld a,(de)
	ld (hl),a
	inc de
	inc l
	ld a,(de)
	ld (hl),a
	inc de
	add hl,bc
	ld a,(de)
	ld (hl),a
	inc de
	inc l
	ld a,(de)
	ld (hl),a
	ret

empItem	incbin "bin/noitem.bin"
;	ds 32
;	db 7,7,7,7

; delete one item A from bag
; CY=1 : something going wrong
delFromBag
	ld c,a			; IX = item DSC
	call findItem
	ret c
	bit 0,(ix+13)		; is in bag?
	ret z
	ld a,(ix+10)		; dec amount
	sub 1
	ret c
	ld (ix+10),a
	ret nz			; if still have items, exit (NC)
dfbg01	res 0,(ix+13)		; delete from bag
	and a
	call rotateBag
	and a
	ret
	
; delete all items A from bag. amount doesn't changed
; CY=1 : no such item
delAllFromBag
	ld c,a
	call findItem
	jr nc,dfbg01
	ret

; add (1 / D) items A to bag
; CY=1 : something going wrong (item didn't added)
addToBag
	ld d,1
addDToBag
	push de
	ld c,a
	call findItem
	pop de
	ret c
	xor a
	bit 0,(ix+13)
	jr z,atbg01
	ld a,(ix+10)
atbg01	add a,d
	ld (ix+10),a
	set 0,(ix+13)
	call updBagPos
	and a
	ret

; rotate bag
; in : CY:0/1 = left/right
rotateBag
	jr c,rBagR
	ld a,(bagPos)
	sub 1
	ret c
	ld (bagPos),a
	jp drawBag
rBagR	ld a,(bagPos)
	inc a
	ld (bagPos),a
	call getCurItem
	inc a
	jp nz,drawBag
	ld a,(bagPos)
	dec a
	ld (bagPos),a
	ret

bagPos	db 0
curItem	db 0xff

bgAdrs	dw 0x50a5,0x50a8,0x50ab
	dw 0x50af
	dw 0x50b3,0x50b6,0x50b9
	
	

/*
; hero items
; {id,amount} x iCount	id = 255 | amount = 0 : no item
hItems	dup iCount
	 db 0xff,0
	edup
*/
