	MODULE menu

; in :  A = flag, BC = YX.pos (FF mean 'place to hero'), DE = callback, HL = punkts.adr
; out: menu - show, work, jump to selected punkt or return if canceled
; flag	b0 don't close window
;	b1 exec.adr is code
exec	push bc
	ld (wFlag),a
	ld (wCall),de
	push hl
	call getItemsUnder
	ld (wItem),bc
	call scanNPC
	ld (wNPC),bc
	call scanELM
	ld (wElem),bc
	call findHero
	pop hl
	pop bc
	ld a,c
	inc a
	jr nz,mexe1
	ld a,(ix + 2)
	inc a
	ld c,a
mexe1	ld a,b
	inc a
	jr nz,mexe2
	ld a,(ix + 3)
	inc a
	ld b,a
mexe2	ld (wPos),bc
	call scanMenu		; scan punkts, get size in DE
	ld (wSize),de
	ld a,(wPos)		; correct pos
	add a,e
	cp 29
	jr c,mexe3
	ld a,29
	sub e
	ld (wPos),a
mexe3	ld a,(wPos + 1)
	add a,d
	cp 18
	jr c,mexe4
	ld a,18
	sub d
	ld (wPos + 1),a
mexe4	ld a,(wSize)
	add a,2
	ld (wpBuf),a
	ld bc,(wPos)		; draw menu
	ld de,0x0100
	call putLine
	ld hl,mBuf
mexe5	ld a,(hl)
	cp 0xff
	jr z,mexeEX
	inc hl
	inc hl
	ld e,(hl)	; DE = DSC of punkt
	inc hl
	ld d,(hl)
	inc hl
	push hl
	exx
	ld de,0x0400
	call prpLine
	exx
	ex de,hl
	inc hl
	inc hl
	inc hl
	inc hl
	LDHL
	ex de,hl
	ld hl,wpBuf + 3
	ld a,(wSize)
mexe6	exa
	ld a,(de)
	and a
	jr z,mexe7
	cp 7
	jr c,mexeCom
	cp 128
	jr c,mexe6a
	xor 64
mexe6a	ld (hl),a
	inc de
	inc hl
mexe6b	exa
	dec a
	jr nz,mexe6
mexe7	call plinA
	pop hl
	jr mexe5
mexeEX	ld de,0x0700
	call putLine
	call reFresh	; show menu
	call noKey
	xor a
	ld (wCPos),a
	call swCursor 	; put cursor
mexeML	halt		; menu main loop
	call aniSR
	ld hl,wKeyTab
	call inKeys
	jr mexeML
mexeCom	push hl
	ld hl,mexe6b
	ex (sp),hl
	push hl
	ld hl,mexCTab
	add a,a
	ADDA H,L
	LDHL
	ex (sp),hl
mxRET	ret

mexCTab	dw mxRET,mpPotionAmount,mpMagicCost,mxRET
	dw mxRET,mxRET,mxRET,mxRET

mpPotionAmount			; 1,id	put 2 digit: amount of potion id
	inc de
	ld a,(de)
	inc de
	push bc
	push de
	push hl
	ld c,a
	call potion.find
mpa00	jr c,mpaNZ
	inc hl
	inc hl
	ld a,(hl)
	cp 99
	jr c,mpa01
	ld a,99
mpa01	pop hl
	push hl
	call putNum2
	pop hl
	pop de
	pop bc
	inc hl
	inc hl
	ret
mpaNZ	pop hl
	pop de
	pop bc
	ld a,0x20
	ld (hl),a
	inc hl
	ld (hl),a
	inc hl
	ret

mpMagicCost			; 2,id	2 digit: MP cost of magic id
	inc de
	ld a,(de)
	inc de
	push bc
	push de
	push hl
	ld c,a
	call magic.findMagic
	jr mpa00

wKeyTab	dw 0x017f,mkSpace	; Space
	dw 0x01fd,mkDown	; A
	dw 0x01fb,mkUp		; Q
	dw 0x01bf,mkSpace	; (enter)
	dw 0x04ef,mkDown	; 8
	dw 0x02ef,mkUp		; 9
	dw 0x01ef,mkSpace	; 0
	db 0

mkUp	ld a,(wCPos)
	sub 1
	ret c
	jr mkdn1
mkDown	ld a,(wCPos)
	inc a
	call wfpA
	ret nc
	ld a,(wCPos)
	inc a
mkdn1	push af
	call swCursor
	pop af
	ld (wCPos),a
	call swCursor
	call getCurrentData
	jp nc,noKey
	ld hl,(wCall)
	ld a,h
	or l
	jp z,noKey
	call callHL
	jp noKey

mkSpace	call getCurrentData	; C = data
	ret nc
	inc hl
	ld e,(hl)	; DE = exec.adr
	inc hl
	ld d,(hl)
	ld a,d		; !0
	or e
	ret z
	pop af		; reset inKeys call
	push de
	push bc
	call swCursor
	call noKey
	ld a,(wFlag)
	rra
	call nc,mClose
	pop bc
	pop hl
	ld a,c
	ld (wData),a
	ld a,(wFlag)
	rra
	rra
	jp nc,script.exec
	jp (hl)

getCurrentData
	call wFindP
	ret nc
	inc hl
	inc hl
	LDHL		; HL = adr of DSC
	inc hl
	ld c,(hl)	; C = data
	scf
	ret

; close current window

mClose	ld hl,(wSize)
	inc h
	inc h
	inc l
	inc l
	ld (wSize),hl
	ld bc,(wPos)
	ld hl,wSize
	ld d,7
	call engine.rmSpr
	jp reFresh

; XOR draw menu pointer (call again to remove)
swCursor
	call wFindP
	ret nc
	ld a,(wPos)
	ld b,a
	ld a,(wPos + 1)
	add a,(hl)
	ld c,a
	rrca
	rrca
	rrca
	and 0xe0
	or b
	ld l,a
	ld a,c
	and 0x18
	or 0x40
	ld h,a
	ld a,(wSize)
	add a,2
	ld c,a
wdrp1	ld b,c
	ld e,l
wdrp2	ld a,(hl)
	cpl
	ld (hl),a
	inc l
	djnz wdrp2
	ld l,e
	inc h
	ld a,h
	and 7
	jr nz,wdrp1
	ret

wFindP	ld a,(wCPos)
wfpA	inc a
	ld c,a
	ld hl,mBuf
wfpCYC	ld a,(hl)
	cp 0xff
	ret z
	inc hl
	ld a,(hl)
	dec hl
	rra
	jr c,wfpSkip
	dec c
	scf
	ret z
wfpSkip	inc hl
	inc hl
	inc hl
	inc hl
	jr wfpCYC

; draw parts of menu window

; in : D = left tile (D, {D+1}, D+2), E = X.size (0:taken from wSize) BC = YX.pos
putLine	call prpLine
plinA	push bc
	ld hl,wpBuf
	LDB d,(layMap+7)
	call engine.drawSpr
	pop bc
	inc b
	ret

prpLine	ld hl,wpBuf+2
	ld (hl),d
	inc hl
	inc d
	ld a,e
	and a
	jr nz,plin0
	ld a,(wSize)
plin0	inc a
plin1	dec a
	jr z,plin2
	ld (hl),d
	inc hl
	jr plin1
plin2	inc d
	ld (hl),d
	ret

; make menu punkt
; A:data; BC:exec.adr; DE:text.adr
formS	ld (ix),0xfe
	jr frmp1
formP	ld (ix),0
frmp1	ld (ix+1),a
	ld (ix+2),c
	ld (ix+3),b
	ld (ix+4),e
	ld (ix+5),d
	dup 6
	 inc ix
	edup
	ld (ix),0xff
	ret

; in : HL = punkts data adr
; out: DE = YX size of menu (w/o border), lines table on mBuf
scanMenu
	ld de,mBuf
	ld (mBufAdr),de
	ld a,0xff
	ld (de),a
	ld de,0x0005
smCYC	ld a,(hl)
	cp 0xff
	ret z
	ld c,a
	push de
	ld de,smTab
	call jumpCDE
	pop de
	jr c,smSKIP
	push hl
	inc d
	ld hl,(mBufAdr)
	ld (hl),d
	inc hl
	ld (hl),a
	inc hl
	pop bc
	ld (hl),c
	inc hl
	ld (hl),b
	inc hl
	ld (hl),0xff
	ld (mBufAdr),hl
	ld hl,6
	add hl,bc
	push hl
	dec hl
	ld a,(hl)
	dec hl
	ld l,(hl)
	ld h,a
	ld c,255
smTL	inc c
	ld a,(hl)
	inc hl
	cp 1
	jr z,smtl2b
	cp 2
	jr z,smtl2b
	and a
	jr nz,smTL
	ld a,c
	cp e
	jr c,smtl1
	ld e,c
smtl1	pop hl
	jr smCYC
smSKIP	ld bc,6
	add hl,bc
	jr smCYC
smtl2b	inc c
	inc hl
	jr smTL

smTab	DBW 0,sm00	; true
	DBW 1,sm01	; NPC ahead
	DBW 2,sm02	; item on ground
	DBW 3,sm03	; item in hand
	DBW 4,sm04	; free place on ground + item in hand
	DBW 5,sm05	; NPC ahead + item in hand
	DBW 6,sm06	; 6,n	bit set : +1 byte
	DBW 7,sm07	; affectable element ahead
	DBW 0xfd,smFD
	DBW 0xfe,smFE
	db 0xff

; C = false, NC = true, A = flags bit (00:menu,FF:text)
sm05	call sm01	; 05 GIVE : sm01 + sm03
	ret c
	jr sm03
sm04	ld bc,(wItem)	; 04 DROP : free place under + sm03
	ld a,b
	inc a
	jr z,sm03
	ld a,c
	inc a
	scf
	ret nz
sm03	ld a,(curItem)		; 03 USE : current item
	jr sm01b
sm02	ld bc,(wItem)		; 02 PICKUP : item under
	jr sm01a
sm01	ld bc,(wNPC)	; 01 TALK : npc ahead
sm01a	ld a,b
	and c
sm01b	inc a
sm01c	scf
	ret z
sm00	xor a		; NC, A = 00 : this is menu punkt
	ret

sm06	inc hl		; 06,n : bit n is set
	ld a,(hl)
	exx
	call bitAdr
	exx
	jr sm01c

sm07	ld bc,(wElem)	; 07 AFFECT : ahead is elem which can be affected
	ld a,b
	and c
	inc a
	scf
	ret z
	push hl
	push de
	push bc
	call findElem
	pop bc
	jr nc,sm07nx
	ld a,(ix+10)
	or (ix+11)
	jr nz,sm07ex
sm07nx	ld c,b
	call findElem
	ccf
	jr c,sm07ex
	ld a,(ix+10)
	or (ix+11)
sm07ex	pop de
	pop hl
	ret c
	xor a
	ret

smFD	scf		; FD : skip this
	ret

smFE	or 0xff		; NC, A = FF : this is not menu punkt
	ret

wPos	dw 0	; X,Y
wSize	dw 0	; dX,dY
wFlag	db 0	; b0 : don't close window when select punkt
wCall	dw 0	; pointer change challback
wData	db 0	; data of selected punkt

wCPos	db 0	; position of cursor

wpBuf	db 30,1
	ds 30

mBufAdr	dw mBuf
mBuf	ds 0x40	; 4 x 0x10 (16 punkts max)

	ENDMODULE
