	MODULE script

; execute script @ HL

exec	ld a,0xff
	ld (dLine),a
;	ld bc,0
	call runScript
	jp txt0100

runScript
	ld a,(hl)
 	and a		; 00 - end
	ret z
	inc hl
	cp 0x20		; 01..1F - command
	jr c,txtMP
	ld e,a		; 20..FF - print char @ bc=YX
	call scp00	
	LDB d,(layMap+7)
	push bc
	push hl
	ld a,e
	cp 128
	jr c,txt2
	xor 64
	ld e,a
txt2	call engine.setTile
	pop hl
	pop bc
	inc c
	jr runScript
txtMP	push hl		; script command call (ret @ txt1), must save HL & BC
	ld hl,runScript
	ex (sp),hl
	push hl
	ld hl,txtTab
	add a,a
	ADDA h,l
	LDHL
	ex (sp),hl
	ret

txtWK	push hl		; wait keypress & clear dialog box
	push de
	call txtUD
	call clrDialog
	push bc
	ld c,0
	call setSysSFX
	call reFresh
	pop bc
	pop de
	pop hl
	ret
	
txtUD	call reFresh
	call noKey
	call waitKey
	jp noKey

clrDialog
	ld bc,(wPos)
	inc b
	push bc
	ld a,(mapBuf)
	ld (menu.wpBuf),a
	call clrDMid
	call reFresh
	xor a
	ld (dLine),a
	pop bc
	inc c
	ret

clrDMid	call cdmid1
	call cdmid1
cdmid1	ld a,(mapSpr)
	sub 2
	ld e,a
	ld d,4
	jp menu.putLine

txtTab	dw txtFF,txt01,txt02,txt03
	dw txt04,txt05,txt06,txt07
	dw txt08,txt09,txtFF,txtFF
	dw txtFF,txt0D,txtFF,txtFF
	dw txtFF,txtFF,txtFF,txtFF
	dw txtFF,txtFF,txtFF,txtFF
	dw txtFF,txtFF,txtFF,txtFF
	dw txtFF,txtFF,txt1e,txt1f

; 01	dialog window

txt01	ld de,txt01t
txtJMP	ld a,(hl)
	inc hl
tjmpA	push hl
	ex de,hl
	ld d,a
txtjp1	ld a,(hl)
	cp 0xff
	jr z,txt01x
	inc hl
	cp d
	jr z,txt01y
	inc hl
	inc hl
	jr txtjp1
txt01y	LDHL
	ex (sp),hl
	ret
txt01x	pop hl
txtFF	ret

txt01t	DBW 0x00,txt0100
	DBW 0x01,txt0101
	DBW 0x02,txt0102
	db 0xff

txt0100	ld a,(dLine)		; 01,00		remove window
	cp 4
	ret nc
tx0100a	push bc
	push hl
	call txtUD
	ld bc,(wPos)
	ld hl,dClrSpr
	ld a,(mapSpr)
	ld (hl),a
	LDB d,(layMap+7)
	call engine.rmSpr
	halt
	call reFresh
	pop hl
	pop bc
	ld a,4
	ld (dLine),a
	ret

txt0101	ld a,scrBank0		; show dialog box
	call bankSR
	push hl
	call findHero
	ld a,(mapSpr+1)
	and a
	rra
	cp (ix + 3)
	ld bc,(vpPos)
	jr c,t0101a
	ld a,(mapSpr+1)
	add a,b
	sub 5
	ld b,a
t0101a	ld (wPos),bc
	ld a,(mapSpr)
	ld (menu.wpBuf),a
	sub 2
	push bc
	ld e,a
	ld d,1
	push de
	call menu.putLine
	call clrDMid
	pop de
	ld d,7
	call menu.putLine
	ld c,0
	call setSysSFX
	call reFresh
	pop bc
	pop hl
	inc b
	inc c
	xor a
	ld (dLine),a
	ret

dClrSpr	db 30,5

txt0102	push bc		; 01,02,x,y,flag,<callback>,<adr>	: exec menu
	call ldBC	; x,y
	ld a,(hl)	; flag
	inc hl
	call ldDE	; <callback>
	push de
	call ldDE
	ex (sp),hl
	ex de,hl
	call menu.exec
	pop hl
	pop bc
	ret

; 02	items

txt02	ld de,txt02t
	jp txt04a
	
txt02t	DBW 0,tx0200
	DBW 1,tx0201
	DBW 2,tx0202
	DBW 3,tx0203
	DBW 4,tx0204
	DBW 5,tx0205
	DBW 6,tx0206
	DBW 7,tx0207
	DBW 8,tx0208
	DBW 9,tx0209
	DBW 10,tx020a
	DBW 11,tx020b
	db 0xff
	
tx0200	ld a,(hl)		; 2,0,id	remove item ID from bag
	inc hl
	push hl
	call delFromBag
tx0200a	call drawBag
	pop hl
	ret

tx0201	ld a,(hl)		; 2,1,id	add item ID to bag
	inc hl
	push hl
	call addToBag
tx0201a	call drawBag
	pop hl
	ret
	
tx0202	ld a,(hl)		; 2,2,id,num	add num items id to bag
	inc hl
	ld d,(hl)
	inc hl
	push hl
	call addDToBag
	jr tx0201a
	
tx0203	call ldBC		; 2,3,n,id	add equip id (0..7) to place n (eArmor, eSword,...)
	push hl
	call equip.add
	pop hl
	ret
	
tx0204	call ldBC		; 2,4,n,id	del equip id (0..7) from place n
	push hl
	call equip.del
	pop hl
	ret

tx0205	ld c,(hl)		; 2,5,id	add potion id
	inc hl
	push hl
	call potion.add
	pop hl
	ret
	
tx0206	ld a,(hl)		; 2,6,id	del potion id; 255=(wData)
	cp 0xff
	jr nz,tx0206a
	ld a,(menu.wData)
tx0206a	ld c,a
	inc hl
	push hl
	call potion.remove
	pop hl
	ret

tx0207	ld c,(hl)		; 2,7,id,map,x,y	put item id on map,x,y
	inc hl
	call findItem
	ld a,(hl)
	inc hl
	call ldBC
	ret c
	ld (ix+1),a
	ld (ix+2),c
	ld (ix+3),b
	ld d,a
	ld a,(curMap)
	cp d
	ret nz
	LDB d,(layMap+3)
	ld e,(ix+4)
	push hl
	call engine.setTile
	call updOn	
	pop hl
	ret
	
tx0208	ld a,(hl)		; 2,8,n		rotate bag items to dir b0,n
	inc hl
	push hl
	rra
	call rotateBag
	call noKey
	pop hl
	ret

tx0209	ld c,(hl)		; 2,9,id	enable magic id
	inc hl
	push hl
	call magic.enable
	pop hl
	ret
	
tx020a	ld c,(hl)		; 2,10,id	disable magic id
	inc hl
	push hl
	call magic.disable
	pop hl
	ret
	
tx020b	push hl			; 2,11		drawBag
	call drawBag
	pop hl
	ret

; 03	bits & vars (used as F1 in animation script)

txt03	ld de,txt03t
	call txt04a
	scf		; for anim.script
	ret
	
txt03t	DBW 0,txt0300
	DBW 1,txt0301
	DBW 2,txt0302
	DBW 3,txt0303
	DBW 4,txt0304
	DBW 0x10,txt0310
	DBW 0x11,txt0311
	DBW 0x12,txt0312
	DBW 0x13,txt0313
	DBW 0x14,txt0314
	DBW 0x15,txt0315
	db 0xff
	
txt0300	ld a,(hl)	; 3,0,n		res bit n
	inc hl
	exx
	call bitAdr
	ld a,c
	cpl
	and (hl)
	ld (hl),a
	exx
	ret

txt0301	ld a,(hl)	; 3,1,n		set bit n
	inc hl
setBit	exx
	call bitAdr
	ld a,(hl)
	or c
	ld (hl),a
	exx
	ret

txt0302	ld a,(hl)	; 3,2,n		inverse bit n
	inc hl
	exx
	call bitAdr
	ld a,(hl)
	xor c
	ld (hl),a
	exx
	ret
	
txt0303	inc hl		; 3,3,n,m	bit n &= bit m
	ld a,(hl)
	exx
	call bitAdr
	ld a,(hl)
	and c
	exx
	jr nz,t0303x
	dec hl
	call txt0300	; res bit
t0303x	inc hl
	ret
	
txt0304	inc hl		; 3,4,n,m	bit n |= bit m
	ld a,(hl)
	exx
	call bitAdr
	ld a,(hl)
	and c
	exx
	jr z,t0303x
	dec hl
	call txt0301
	jr t0303x

txt0310	ld a,(hl)	; 3,16,n,x	var n = x
	inc hl
	call getVar
	ld a,(hl)
	inc hl
	ld (de),a
	ret

txt0311	ld a,(hl)	; 3,17,n,m	var n = var m
	inc hl
	call getVar
	push de
	ld a,(hl)
	inc hl
	call getVar
	pop de
	ld (de),a
	ret

txt0312	ld a,(hl)	; 3,18,n,x	var n += x
	inc hl
	call getVar
	add a,(hl)
	inc hl
	ld (de),a
	ret
	
txt0313	inc hl		; 3,19,n,m	var n += var m
	ld a,(hl)
	dec hl
	call getVar
	ld c,a
	ld a,(hl)
	call getVar
	add a,c
	ld (de),a
	inc hl
	inc hl
	ret

txt0314	ld a,(hl)	; 3,20,n,x	var n -= x
	inc hl
	call getVar
	sub (hl)
	inc hl
	ld (de),a
	ret
	
txt0315	inc hl		; 3,21,n,m	var n += var m
	ld a,(hl)
	dec hl
	call getVar
	ld c,a
	ld a,(hl)
	call getVar
	sub c
	ld (de),a
	inc hl
	inc hl
	ret

; 04	animation manipulate
	
txt04	ld de,txt04t
txt04a	ld (storeBC+1),bc
	call txtJMP
storeBC	ld bc,0
	ret

txt04t	DBW 0,tx0400
	DBW 1,tx0401
	DBW 2,tx0402
	DBW 3,tx0403
	DBW 4,tx0404
	DBW 5,tx0405
	DBW 6,tx0406
	DBW 7,tx0407
	DBW 8,tx0408
	DBW 9,tx0409
	DBW 10,tx040a
	DBW 11,tx040b
	DBW 12,tx040c
	DBW 13,tx040d
	db 0xff

tx0400	ld a,(hl)	; 04,00,id,<adr>	set npc anim
	inc hl
	call ldDE
	push hl
	cp 0xf8
	call nc,battle.getXNPC
tx0400a	call setCAni
	pop hl
	ret
	
tx0401	ld a,(hl)	; 04,01,id,<adr>	set element anim
	inc hl
	call ldDE
	push hl
	call setEAni
	pop hl
	ret

tx0402	push bc		; 04,02,id		activate door id
	ld a,(hl)
	inc hl
	push hl
	call actDoor
	pop hl
	pop bc
	ret
	
tx0403	push bc		; 04,03,id		deactivate door id
	ld a,(hl)
	inc hl
	push hl
	call delDoor
	pop hl
	pop bc
	ret
	
tx0404	ld bc,findElem	; 04,04,id,<adr>	set sprite <adr> to element id
tx0404i	ld (tx0404p+1),bc
	ld c,(hl)
	inc hl
	call ldDE
	push hl
	push de
tx0404p	call findElem
	pop de
	jr nc,tx0404e
	ld (ix+5),e
	ld (ix+6),d
	ld a,(curMap)
	cp (ix+1)
	call z,aniPTS
tx0404e	pop hl
	ret
	
tx0405	push bc		; 04,05,id,map,x,y	move NPC id to map,x,y
	ld c,(hl)
	inc hl
	push hl
	call findNPC
tx0405a	jr nc,tx0405x
	ld a,(curMap)	; remove from current screen
	cp (ix+1)
	call z,aniRMS
	pop hl
	ld a,(hl)	; map=255:curMap
	cp 0xff
	jr nz,tx0405b
	ld a,(curMap)
tx0405b	ld (ix+1),a	; map
	inc hl
	ld a,(hl)
	ld (ix+2),a	; x
	inc hl
	ld a,(hl)
	ld (ix+3),a	; y
	inc hl
	push hl
	ld a,(curMap)
	cp (ix+1)
	call z,aniPTS
	ld a,(ix)	; if hero is moved, change current map
	and a
	ld a,(ix+1)
	call z,map.setMap
tx0405x	pop hl
tx0405e	pop bc
	ret

tx0406	push bc		; 04,06,id,map,x,y	move elem id to map,x,y (id 255 -> wElem)
	ld a,(hl)
	inc hl
	cp 255
	jr nz,t0406a
	ld a,(wElem)
t0406a	ld c,a
	push hl
	call findElem
	jr tx0405a

tx0407	ld bc,findNPC	; 04,07,id,<adr>	set sprite <adr> to NPC id
	jr tx0404i

tx0408	ld c,(hl)	; 04,08,id,<adr>	set affect script <adr> to elem id
	inc hl
	push hl
	call findElem
	pop hl
	call ldDE
	ret nc
	ld (ix+10),e
	ld (ix+11),d
	ret
	
tx0409	ld c,(hl)	; 04,09,id		wait NPC id animation end (255:selected enemy during battle)
	inc hl
	push hl
	ld a,c
	cp 0xf8
	call nc,battle.getXNPC
tx0409z	call waitNPC
	pop hl
	ret

tx040a	ld c,(hl)		; 04,0a,id		activate zone id
	inc hl
	push hl
	call setZone
	pop hl
	ret
	
tx040b	ld c,(hl)		; 04,0b,id		deactivate zone id
	inc hl
	push hl
	call delZone
	pop hl
	ret

tx040c	push hl			; 04,0c,<adr>		scan zones, exec script and jump adr if zone activated (adr=0:continue)
	call scanZones
	pop hl
	call ldDE
	ret z
	ld a,d
	or e
	ret z
	ex de,hl
	ret
	
tx040d	ld c,(hl)		; 04,0d,id		wait elem id animation end
	inc hl
	push hl
	call waitElem
	pop hl
	ret

; 05	Info lines

txt05	ld de,txt05t
	jp txt04a
	
txt05t	DBW 0x00,tx0500
	DBW 0x01,tx0501
	DBW 0x02,tx0502
	DBW 0x03,tx0503
	DBW 0x04,tx0504
	db 0xff
	
tx0500	call clrInfoLine	; 05,00,id,hp,mp	add max HP,MP to NPC id and show progress in info line
	inc de
	ld a,(hl)
	inc hl
	exx
	ld c,a
	call findNPC
	exx
	jr nc,t0500x
	ld a,(hl)
	inc hl
	and a
	push hl
	call nz,tx0500h
	pop hl
	ld a,(hl)
	inc hl
	and a
	push hl
	call nz,tx0500m
	call t0501e
	pop hl
	ret
t0500x	inc hl
	inc hl
	ret

tx0501	call formInfoLine	; 05,01,text,00		show text in info line
t0501e	push hl
	call showInfoLine
	call noKey
	ld b,250
	call doWait
	call noKey
	call rmInfoLine
	pop hl
	ret
	
tx0502	ld a,(curItem)		; 05,02		show current item name
	ld c,a
	inc a
	scf
	ret z
	call findItem
	ret c
	push hl
	ld l,(ix+11)
	ld h,(ix+12)
	call formInfoLine
	call showInfoLine
	call noKey
	call rmInfoLine
	pop hl
	ret
	
tx0503	ld d,(hl)		; 05,03,lay,x,y,{row},00	draw row of tiles
	inc hl
	call ldBC
	push de
	push bc
	call formInfoLine
	pop bc
	pop de
	push hl
	call sinf01
	pop hl
	ret
	
tx0504	ld a,(hl)		; 05,04,lay,x,y,dx,dy		clear rect (x,y,dx,dy) in layer lay
	inc hl
	call ldBC
	call ldDE
	ld (mapBuf),de
	ld d,a
	push hl
	call rinf01
	pop hl
	ret

formInfoLine			; print text from HL to 30-char buffer
	call clrInfoLine
	ld c,30
	inc de
t0501a	ld a,(hl)
	inc hl
	and a
	ret z
	cp 128
	jr c,t0501b
	xor 64
t0501b	ld (de),a
	inc de
	dec c
	jr nz,t0501a
t0501c	ld a,(hl)
	inc hl
	and a
	jr nz,t0501c
	ret
	
showInfoLine
	ld bc,0x1301
	LDB d,(layMap+7)
sinf01	ld hl,mapBuf
	call engine.drawSpr
	jp reFresh

rmInfoLine
	ld bc,0x1301
	LDB d,(layMap+7)
rinf01	ld hl,mapBuf
	call engine.rmSpr
	jp reFresh

doWait	halt
	push bc
	call aniSR
	pop bc
	xor a
	in a,(254)
	cpl
	and 31
	ret nz
	djnz doWait
	ret

clrInfoLine
	ld de,0x0120
	ld (mapBuf),de
	ld de,mapBuf+2
	ld b,32
	ld a,0x20
cil01	ld (de),a
	inc de
	djnz cil01
	ld de,mapBuf+2
	ret

tx0500h	ld c,a		; +A HP
	ld a,(ix+24)
	add a,c
	jr nc,t0500h1
	ld a,0xff
t0500h1	ld (ix+24),a
	ld hl,hpStr
	jr tx0500s
tx0500m	ld c,a		; +A magic
	ld a,(ix+25)
	add a,c
	jr nc,t0500m1
	ld a,0xff
t0500m1	ld (ix+25),a
	ld hl,mpStr
/*
	jr tx0500s
tx0500e	push hl		; +BC exp
	ld hl,(expa)
	add hl,bc
	jr nc,t0500e1
	ld hl,0xffff
t0500e1	ld (expa),hl
	pop hl
	ld hl,expStr
*/
tx0500s	ld a,c
	ld bc,5
	ldir
infNum	cp 100
	jr nc,inum3
	cp 10
	jr nc,inum2
	jr inum1
inum3	ld b,100
	call inumD
inum2	ld b,10
	call inumD
inum1	add a,"0"
	ld (de),a
	inc de
	ld a,0x20
	ld (de),a
	inc de
	ld (de),a
	inc de
	ret

inumD	ld c,"0"-1
ind01	inc c
	sub b
	jr nc,ind01
	add a,b
	ld b,a
	ld a,c
	ld (de),a
	inc de
	ld a,b
	ret

hpStr	db " HP +"
mpStr	db " MP +"
expStr	db "EXP +"
	
; 06	Battle actions

txt06	ld de,txt06t
	jp txt04a
	
txt06t	DBW 0,tx0600
	DBW 1,tx0601
	DBW 2,tx0602
	DBW 3,tx0603
	DBW 4,tx0604
	DBW 5,tx0605
	DBW 6,tx0606
	DBW 7,tx0607
	DBW 8,tx0608
	DBW 9,tx0609
	DBW 0x0a,tx060A
	DBW 0x0b,tx060B
	DBW 0x0c,tx060C
	DBW 0x0d,tx060D
	DBW 0x0e,tx060E
	DBW 0x0f,tx060F
	DBW 0x10,tx0610
	DBW 0x11,tx0611
	DBW 0x12,tx0612
	DBW 0x13,tx0613
	DBW 0x14,tx0614
	DBW 0x15,tx0615
	DBW 0x16,tx0616
	DBW 0x17,tx0617
	DBW 0x18,tx0618
	DBW 0x19,tx0619
	DBW 0x1a,tx061A
	DBW 0x1b,tx061B
	DBW 0x1c,tx061C
	DBW 0x1d,tx061D
	DBW 0x1e,tx061E
	DBW 0x1f,tx061F
	DBW 0x20,tx0620
	DBW 0x21,tx0621
	DBW 0x22,tx0622
	DBW 0x23,tx0623
	db 0xff
	
tx0600	call tx06z	; 06,00,id,n	add n HP to battle npc id & show it 2s
	jr c,tx0600e	; HL = bnpc.adr, B = value
	ld c,(hl)	; C = npc.id
	inc hl
	inc hl		; skip anim.tab.adr
	inc hl
tx0600z	ld a,(hl)
	add a,b
	inc hl
	cp (hl)
	jr c,tx0600a
	ld a,(hl)
tx0600a	dec hl
tx0600b	ld (hl),a
	call battle.showDamage
tx0600s	call battle.fHeroHM
tx0600e	pop hl
	ret
	
tx0601	call tx06z		; 06,01,id,n	sub n HP from battle npc id & show it 2s
	jr c,tx0600e
	ld c,(hl)
	inc hl
	inc hl
	inc hl
	ld a,(hl)
	sub b
	jr nc,tx0600b
	ld b,(hl)
	xor a
	jr tx0600b
	
tx0602	call tx06z		; 06,02,id,n	add n MP to battle npc id
	jr c,tx0600e
	ld de,5
	add hl,de
	ld a,(hl)
	add a,b
	inc hl
	cp (hl)
	jr c,tx0602a
	ld a,(hl)
tx0602a	dec hl
tx0602b	ld (hl),a
	jr tx0600s
	
tx0603	call tx06z		; 06,03,id,n	sub n MP from battle npc id
	jr c,tx0600e
	ld de,5
	add hl,de
	ld a,(hl)
	sub b
	jr nc,tx0602b
	xor a
	jr tx0602b

tx0621	ld a,(hl)		; 06,21,n		select ally, put it id to XNPC[n]
	inc hl
	push hl
	call battle.getXNPC
	push hl
	call battle.selAlly
	pop bc
	pop hl
	jr t0604a
	
tx0604	ld a,(hl)		; 06,04,n,<adr>		select enemy, put id to XNPC[n] | jump <adr> when canceled
	inc hl
	push hl
	call battle.getXNPC
	push hl
	call battle.selTarget
	pop bc
	pop hl
	call ldDE
	ex de,hl
	jp c,tx060B			; canceled, HL = DE (jump adr)
	ex de,hl
t0604a	ld a,(iy)
	ld (bc),a
	ret

tx0622	ld a,(hl)			; 06,22,n		pick random ally in XNPC[n]
	inc hl
	push hl
	call battle.getXNPC
	push hl
	call battle.pickAlly
	pop bc
	pop hl
	jr t0604a
	
tx0605	ld a,(hl)			; 06,05,n		pick random enemy in XNPC[n]
	inc hl
	push hl
	call battle.getXNPC
	push hl
	call battle.pickEnemy
	pop bc
	pop hl
	jr t0604a
	
tx0606	ld b,(hl)	; 06,06,id1,id2,adr	bDamage = damage of std.attack npc.id1 to npc.id2. if adr != 0, attacker has non-standard ATK table
	inc hl
	ld c,(hl)
	inc hl
	push hl
	call tx0606x	; victim (C)
	ld (fatkAP),de
	push bc
	push hl
	ld c,b		; attacker (B)
	call tx0606x
	ex de,hl
	ld (fatkIP),hl
	ld a,c
	pop hl
	pop bc
	ld b,a		; (B,DE) attacks (C,HL)
	ex (sp),hl
	push bc
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	jr z,t0606a
	ld d,b
	ld e,c
t0606a	pop bc
	ex (sp),hl
	call battle.getDamage
	pop hl
	ret

tx0606x	call battle.findBNPC	; C = id, HL = bnpc.dsc
	ld de,7
	add hl,de
	LDHL		; HL = ATK/DEF tab.adr
	call findNPC	; IX = npc.dsc
	ld e,(ix+2)	; E,D = X,Y
	ld d,(ix+3)
	ret

tx0607	ld a,(hl)		; 06,07,flag		show battle HP/MP window on/off
	inc hl
	push hl
	and a
	push af
	call nz,battle.fShowHM
	pop af
	call z,battle.fDelHM
	pop hl
	ret

tx0608	ld c,(hl)	; 06,08,id,n	run battle script id:n to battle.NPC id
	inc hl
	ld a,(hl)
	inc hl
	push hl
	call battle.runScript
	pop hl
	ret
	
tx0609	ld c,(hl)	; 06,09,id,st,<adr>	if battle npc id is (st ? alive : dead), jump <adr>
	inc hl
	push hl
	call battle.findBNPC
	inc hl
	inc hl
	inc hl
	ld c,(hl)
	pop hl
	ld a,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	and a
	ld a,c
	jr z,t0609d
	and a		; check if HP != 0 (alive)
	ret z
	ex de,hl
	ret
t0609d	and a		; check if HP == 0 (dead)
	ret nz
	ex de,hl
	ret

tx060A	push hl			; 06,0a : exec magic menu
	ld c,0
	call battle.findBNPC
	ld de,5
	add hl,de
	ld a,(hl)
	ld ix,(fbSpace)
	call magic.makeMenu
	xor a
ftk01z	ld bc,0x0101		; TODO : menu position
	ld de,0
	ld hl,(fbSpace)
	call menu.exec
	pop hl
	ret

tx060B	ld a,(battle.bFlag)		; 06,0b : cancel current turn, back to actions menu
	or 1
	ld (battle.bFlag),a
	ret

tx060C	push hl			; 06,0c : exec potion menu
	ld ix,(fbSpace)
	call potion.makeMenu
	xor a
	jr ftk01z

tx060D	ld c,(hl)		; 06,0d,id,n,<adr> : if battle NPC id HP < n, jump <adr>
	inc hl
	push hl
	call battle.findBNPC
	inc hl
	inc hl
	inc hl
	ld a,(hl)
	pop hl
	cp (hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ret nc
	ex de,hl
	ret
	
tx060E	ld c,(hl)		; 06,0e,id,n : NPC HP = n
	inc hl
	push hl
	call battle.findBNPC
	inc hl
	inc hl
	inc hl
	ex de,hl
	pop hl
	ld a,(hl)
	inc hl
	ld (de),a
	inc de
	ld (de),a
	ret
	
tx060F	ld a,(hl)		; 06,0f,n,id : XNPC[n] = id
	inc hl
	ld e,(hl)
	inc hl
	push hl
	call battle.getXNPC
	ld (hl),e
	pop hl
	ret

tx0610	ld c,(hl)		; 06,10,npc,id : use potion id, don't remove any from bag
	inc hl
	push hl
	call potion.activate
	pop hl
	ret

tx0611	ld b,0			; 06,11,id,<adr> : replace ATK values
	jr tx06112
tx0612	ld b,1			; 06,12,id,<adr> : replace DEF values
tx06112	ld c,(hl)
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	push de
	call battle.findBNPC
	pop de
	jr c,tx0611x
	ld a,b
	ld bc,7
	add hl,bc
	ld c,a
	LDHL
	add hl,bc
	ld b,4
tx0611a	ld a,(de)
	ld (hl),a
	inc de
	inc hl
	inc hl
	djnz tx0611a
tx0611x	pop hl
	ret
	
tx0613	ld c,(hl)		; 06,13,id,<adr>	replace AT of battle NPC id
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	push de
	call battle.findBNPC
	pop de
	jr c,tx0611x
	inc hl
	ld (hl),e
	inc hl
	ld (hl),d
	pop hl
	ret
	
tx0614	ld c,(hl)		; 06,14,id,prc		maxHP/HP of NPC id +prc%
	inc hl
	ld e,(hl)
	inc hl
	push hl
	push de
	call battle.findBNPC
	pop de
	jr c,tx0611x
	inc hl
	inc hl
	inc hl
	inc hl
	ld d,(hl)
	push hl
	call multDE
	pop hl
	ld a,(hl)
	add a,d
	jr nc,t0614a
	ld a,255
t0614a	ld (hl),a
	dec hl
	ld (hl),a
	pop hl
	ret
	
tx0615	ld e,(hl)		; 06,15,prc	damage +prc%
	inc hl
	push hl
	ld a,(battle.bDamage)
	ld d,a
	ld c,a
	call multDE
	ld a,c
	add a,d
	jr nc,t0615a
	ld a,0xff
t0615a	ld (battle.bDamage),a
	pop hl
	ret
	
tx0616	ld e,(hl)		; 06,16,prc	damage -prc%
	inc hl
	push hl
	ld a,(battle.bDamage)
	ld d,a
	ld c,a
	call multDE
	ld a,c
	sub d
	jr nc,t0615a
	xor a
	jr t0615a
	
tx0617	ld a,(hl)		; 06,17,num	damage = num
	inc hl
	ld (battle.bDamage),a
	ret
	
tx0618	call tx06z	; 06,18,id,prc	up HP to prc% for npc id & show it 2s
	jp c,tx0600e
	ld c,(hl)
	inc hl
	inc hl
	inc hl
	push hl
	inc hl
	ld d,(hl)
	ld e,b
	call multDE
	ld b,d
	pop hl
	jp tx0600z

tx0619	push hl			; 06,19		run battle start script
	ld hl,(battle.startScriptAdr)
t0619a	ld a,h
	or l
	call nz,runScript
	pop hl
	ret
	
tx061A	push hl			; 06,1a		run battle win script
	ld hl,(battle.winScriptAdr)
	ld a,0xa7
t061aa	ld (battle.brFlag),a
	jr t0619a

tx061B	push hl			; 06,1b		run battle lose script
	ld hl,(battle.loseScriptAdr)
	ld a,0x37
	jr t061aa
	
tx061C	push hl			; 06,1c,<adr>	if all enemies dead, jump <adr>
	call battle.fchkWin
t061ca	pop hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ret nc
	ex de,hl
	ret
	
tx061D	push hl			; 06,1d,<adr>	if hero is dead, jump <adr>
	call battle.fchkLos
	jr t061ca
	
tx061E	push hl			; 06,1e		battle turn
	call battle.turn
;	ld a,fxTURN
;	call battle.applyAffect
	pop hl
	ret

tx061F	call ldBC		; 06,1f,npc,id	add affect id to npc
	push hl
	call battle.addEffect
	pop hl
	ret

tx0620	call tx06z		; 06,20,id,prc	raise MP to NPC id
	jp c,tx0600e
	inc hl
	inc hl
	inc hl
	inc hl
	inc hl
	inc hl
	push hl
	ld d,(hl)
	ld e,b
	call multDE
	pop hl
	ld e,(hl)
	dec hl
	ld a,(hl)
	add a,d
	jr nc,t0620a
	ld a,0xff
t0620a	cp e
	jr c,t0620b
	ld a,e
t0620b	ld (hl),a
	call battle.fHeroHM
	pop hl
	ret
	
tx0623	ld a,(hl)		; 06,23,n	n = 0|* = res|set cancel bit
	inc hl
	ld de,0xfe01
	and a
	jr nz,t0623a
	ld e,0
t0623a	ld a,(battle.bFlag)
	and d
	or e
	ld (battle.bFlag),a
	ret

/*
tx06x	ld b,(hl)		; b,de : atacker, c,hl : victim
	inc hl
	ld c,(hl)
	inc hl
	push hl
	call battle.findBNPC	; hl = bdsc of npc c
tx06xa	ld de,7
	add hl,de
	LDHL
	ld (tx06wrd),hl		; victim.tab
	ld a,b
	ld b,c
	ld c,a
	call battle.findBNPC	; hl = bdsc of npc b (through c)
tx06xb	ld de,7
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)		; de : atacker.tab
	ld a,b
	ld b,c
	ld c,a
	pop hl
	ret
	
tx06wrd	dw 0
*/
tx06z	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ex (sp),hl
	push hl
	ld a,b
	inc a
	jr nz,t060sa
	LDB b,(battle.bDamage)
t060sa	call battle.findBNPC
	ld a,h
	or l
	ret nz
	scf
	ret

; 07 : game actions

txt07	ld de,txt07t
	jp txt04a
	
txt07t	DBW 0,cTalk
	DBW 1,cGive
	DBW 2,cPickUp
	DBW 3,cDrop
	DBW 4,cAffect
	DBW 5,cUse
	DBW 6,cEquipment
	DBW 7,cCraft
	db 255

cTalk	call ldDE	; 07,00,<adr>		talk by table <adr>
	push hl
	push de
	call scanNPC
	pop hl
ctlkL	ld a,(hl)
	inc hl
	cp 0xff
	jr z,ctlkX
	cp c
	jr z,ctlkY
	inc hl
	inc hl
	jr ctlkL
ctlkY	LDHL
	call script.exec
ctlkX	pop hl
	ret

cGive	call ldDE	; 07,01,<adr>		give by tab <adr>
	push hl
	push de
	call scanNPC	; C = NPC id
	LDB b,(curItem)
	pop hl
	ld a,c
	inc a
	jr z,ctlkX
	ld a,b
	inc a
	jr z,ctlkX
cgivL	ld a,(hl)
	inc hl
	cp 0xff
	jr z,cgivX
	cp b
	ld a,(hl)
	inc hl
	jr nz,cgivN
	cp c
	jr z,ctlkY
cgivN	inc hl
	inc hl
	jr cgivL
cgivX	inc hl
	jr ctlkY
	
cPickUp	push hl		; 07,02			pick up item : ground -> bag
	call getItemsUnder
	call findItem
	jr c,cpkuX	
	ld a,c
	ld d,(ix+10)
	call addDToBag
	jr c,cpkuX
	ld c,(ix+2)
	ld b,(ix+3)
	LDB d,(layMap+3)
	call engine.rmTile
	ld (ix+1),0xff
	call updOn
	call drawBag
	call noKey
cpkuX	pop hl
	ret
	
cDrop	ld a,(curItem)	; 07,03		drop item if possible : bag -> ground
	inc a
	jp z,noKey
	push hl
	call findHero
	call getFeet
	push hl
	LDB d,(layMap+3)
	call engine.getTile
	pop de
cdrL	ld a,(hl)
	and a
	jr z,cdrY
	inc l
	inc c
	dec e
	jr nz,cdrL
	jr cdrX
cdrY	push bc
	LDB c,(curItem)
	call findItem
	pop bc
	jr c,cdrX
	ld (ix+2),c
	ld (ix+3),b
	LDB (ix+1),(curMap)	; put item on new place
	res 0,(ix+13)		; not in bag
	ld e,(ix+4)
	LDB d,(layMap+3)
	call engine.setTile
	call updOn
	call drawBag
cdrX	call noKey
	pop hl
	ret

cAffect	push hl			; 7,4		affect
	call scanELM
	ld (wElem),bc
	call findElem
	jr nc,cdrX
	ld l,(ix+10)
	ld h,(ix+11)
	ld a,h
	or l
	call nz,script.exec
	jr cdrX
	
cUse	call ldDE		; 7,5,<adr>		use by table <adr>
	push hl
	ex de,hl
	ld a,(curItem)
	ld c,a
	inc a
	jr z,cuseEX
cuseL	ld a,(hl)
	inc hl
	cp c
	jr z,cuseY
	inc a
	jr z,cuseY
	inc hl
	inc hl
	jr cuseL
cuseY	LDHL
	call script.exec
	call noKey
cuseEX	pop hl
	ret

cEquipment		; 07,06		select equipment
	push hl
	call equip.exec
	pop hl
	ret

cCraft	push hl
	call craft.exec
	pop hl
	ret

; 08 : game control
	
txt08	ld de,txt08t
	jp txt04a
	
txt08t	DBW 0,cKeyScan
	DBW 1,cGameInit
	DBW 2,tx0802
	DBW 4,cHeroInit
	DBW 5,cDebugStop
	DBW 6,cLayInit
	DBW 7,cViewport
	DBW 8,tx0808
	DBW 9,tx0809
	DBW 10,tx080a
	DBW 11,tx080b
	DBW 12,tx080c
	DBW 13,tx080d
	DBW 14,tx080e
	DBW 15,tx080f
	DBW 17,tx0811
	db 255
	
cKeyScan		; 08,00,<adr>	scan keys of tab <adr> and call scripts
	call ldDE
	push hl
	ex de,hl
	call scanKeys
	call nz,script.exec
	pop hl
	ret

cGameInit		; 08,01		init game data
	push hl
	call initGame
	pop hl
	ret
	
tx0802	ld a,(hl)	; 08,02,col	out (FE),col : change border
	inc hl
	out (0xfe),a
	ret

/*
cDrawSkin		; 08,02,<adr>	depack & draw skin from <adr> (xBank)
	call ldDE
	push hl
	push de
	xor a
	out (0xfe),a
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x2ff
	ld (hl),l
	ldir
	pop hl
	ld a,(curBank)
	push af
	call xBank
	ld de,0x4000
	call DEHRUST
	pop af
	call setBank
	pop hl
	ret
*/

cHeroInit		; 8,4,hp,mp,<at.adr>	init hero params
	call ldDE
	ld (hpInit),de
	call ldDE
	ld (heroData),de
	ret
	
cDebugStop		; 8,5	debug : stop here
	nop
	jr $
	ret

cLayInit		; 8,6,msk,box		init gfx layers
	ld a,(hl)
	ld (engine.LayType),a
	inc hl
	ld a,(hl)
	ld (boxMask),a
	inc hl
	ret
	
cViewport		; 8,7,x,y,dx,dy		set viewport
	call ldBC
	call ldDE
	ld (vpPos),bc
	ld a,c
	ld (aff04m0+1),a
	ld a,e
	ld (aff04m1+1),a
	ld a,b
	ld (aff04n0+1),a
	ld a,d
	ld (aff04n1+1),a	
	push hl
	ld (mapSpr),de
	call engine.setArea
	pop hl
	ret
	
tx0808	ld a,(hl)	; 8,8,atr		fill atrs
	inc hl
	push hl
	ld hl,0x5800
	ld de,0x5801
	ld bc,767
	ld (hl),a
	ldir
	pop hl
	ret
	
tx0809	push hl		; 8,9,atr		gradient cls, fill atrs
	call gradCls
t0809a	pop hl
	ld a,(hl)
	inc hl
	push hl
	ld hl,0x5800
	ld de,0x5801
	ld bc,767
	ld (hl),a
	ldir
	call engine.cls
	call engine.reset
	pop hl
	ret
	
tx080a	push hl		; 8,10,atr		atribute cls
	call atrCls
	jr t0809a

tx080b	call ldBC	; 8,11,<src>,<dst>	dehrust1 (curBank)
	call ldDE
	push hl
	ld h,b
	ld l,c
	call DEHRUST
	pop hl
	ret
	
tx080c	call ldBC	; 8,12,dx,dy,<adr>,<scr>	draw sprite
	call ldDE
	push de
	call ldDE
	ex (sp),hl	; BC=dYdX, HL=<adr>, DE=<scr>
	call outSpr
	pop hl
	ret
	
tx080d	call ldBC	; 8,13,val,len,<adr>	fillmem
	call ldDE
	push hl
	ex de,hl
t080da	ld (hl),c
	inc hl
	djnz t080da
	pop hl
	ret
	
tx080e	ld a,(hl)	; 8,14,msk		set map format
	inc hl
	ld (layMap),a
	ret

tx080f	call ldDE	; 8,15,<adr>		init lay colors
	push hl
	ld hl,engine.lColors
	ld bc,8
t080fa	ex de,hl
	ldir
	pop hl
	ret

tx0811	call ldDE	; 8,17,<adr>		init layMap
	push hl
	ld hl,layMap
	ld bc,8
	jr t080fa
	

; 09	sound

txt09	ld de,txt09t
	jp txt04a
	
txt09t	DBW 0,tx0900
	DBW 1,tx0901
	DBW 2,tx0902
	db 0xff

tx0900	ld a,(hl)		; 09,00,n	n=0/* : off/on music
	inc hl
	push hl
	and a
	jr nz,t09001
t09000	call muzOff
	jr t0900a
t09001	call muzOn
t0900a	call noKey
	pop hl
	ret

tx0901	ld c,(hl)		; 09,01,id	set music id
	inc hl
	push hl
	call setMuz
	pop hl
	ret
	
tx0902	ld c,(hl)		; 09,02,id	play SFX id
	inc hl
	push hl
	call setSFX
	pop hl
	ret

; 0D	CR+LF
	
txt0D	ld a,(dLine)
	inc a
	ret z
	ld (dLine),a
	inc b
	ld a,(wPos)
	inc a
	ld c,a
scp00	ld a,(dLine)	; if need, draw dialog box
	cp 0xff
	push de
	call z,txt0101
	cp 3		; if need, wait keypress & clear window
	call nc,txtWK
	pop de
	ret

; 1e	misc

txt1e	ld de,txt1et
	jp txt04a
	
txt1et	DBW 0,txt1e00
	DBW 1,txt1e01
	DBW 2,txt1e02
	DBW 3,txt1e03
	DBW 4,txt1e04
	DBW 5,txt1e05
	DBW 6,txt1e06
	DBW 7,txt1e07
	DBW 8,txt1e08
	DBW 9,txt1e09
	DBW 10,txt1e0a
	DBW 11,txt1e0b
	DBW 12,txt1e0c
	db 0xff
	
txt1e00	push hl			; 1e,00		halt + ani.cycle
	halt
	call aniSR
	pop hl
	ret
	
txt1e01	ld c,(hl)		; 1e,01,n,<adr>	exec battle n and go <adr> if lose
	inc hl
	push hl
	call battle.exec
	pop hl
	call ldDE
	ret z	; not found
	ret nc	; win
	ex de,hl	; lose
	ret
	
txt1e02	push hl			; 1e,02			clear craft ingridients + result
	ld hl,craft.cIngrA
	ld bc,0x05ff
tx1e02a	ld (hl),c
	inc hl
	djnz tx1e02a
	call craft.dcItems
	pop hl
	ret

txt1e03	call ldDE		; 1e,03,<adr>		call script in page scrBank1
	ld a,scrBank1
	call bankSR
	jr tx1e07a

txt1e04	push hl			; 1e,04			wait keypress
	call reFresh
	pop hl
	call noKey
	call waitKey
	jp noKey

txt1e05	ld a,(hl)		; 1e,05,flag		flag = 0|* = off|on animation
	inc hl
	push hl
	and a
	call z,aniOff
	call nz, aniOn
	call aniSR
	pop hl
	ret

txt1e06	ld a,(hl)		; 1e,06,n		n HALTs
	inc hl
	push bc
	push hl
tx1e06a	push af
	halt
	call aniSR
	pop af
	dec a
	jr nz,tx1e06a
	pop hl
	pop bc
	ret

txt1e07	call ldDE	; 1e,07,<adr>		call script adr
tx1e07a	push hl
	ex de,hl
	call runScript
	pop hl
	ld (storeBC+1),bc
	ret

txt1e08	call ldDE	; 1e,08,<adr>		call adr (code execution)
	push hl
	ex de,hl
	call callHL
	pop hl
	ret
	
txt1e09	ld a,(hl)	; 1e,09,n		set map n (n=255 : hero map)
	inc hl
	push hl
	cp 0xff
	jr nz,tx1e09a
	call engine.updAll
	call findHero
	ld a,(ix+1)
tx1e09a	call map.setMap
	pop hl
	ret

txt1e0a	push hl		; 1e,0a			return to checkpoint
	call restState
	pop hl
	ret
	

txt1e0b	call aniOff	; 1e,0b			restart game
	call aniSR
	jp gameStart

txt1e0c	ld a,(hl)
	inc hl
	and a
	ld a,0x37
	jr z,t1e0c1
	ld a,0xa7
t1e0c1	ld (L7Flag),a
	ret

; 1F	condition jumps
; subcoms returns CY=1 on true

txt1f	ld de,txt1ft
	call txt04a
	jr c,txt1fy
	inc hl
	inc hl
	ret
txt1fy	LDHL
	ret

txt1ft	DBW 0x00,txt1f00
	DBW 0x01,txt1f01
	DBW 0x02,txt1f02
;	DBW 0x03,txt1f03
	DBW 0x04,txt1f04
	DBW 0x05,txt1f05
	DBW 0x06,txt1f06
	DBW 0x07,txt1f07
	DBW 0x08,txt1f08
	DBW 0x09,txt1f09
	DBW 0x0a,txt1f0a
	DBW 0x0b,txt1f0b
	DBW 0x0c,txt1f0c
;	DBW 0x0d,txt1f0d
	DBW 0x0e,txt1f0e
	DBW 0x0f,txt1f0f
	DBW 0x10,txt1f10
	DBW 0x11,txt1f11
	DBW 0x12,txt1f12
	DBW 0x13,txt1f13
	DBW 0x14,txt1f14
	db 0xff

txt1f00	ld a,(hl)	; 1f,0,n,<adr>		if bit n res
	inc hl
	exx
	call bitAdr
	exx
	ret nz
	scf
	ret
	
txt1f01	ld a,(hl)	; 1f,1,n,<adr>		if bit n set
	inc hl
	exx
	call bitAdr
	exx
	ret z
	scf
	ret

txt1f02	scf		; 1f,2,<adr>		true
	ret

/*
txt1f03	ld c,(hl)	; 1f,3,id,<adr>		if have item ID
	inc hl
	push hl
	call findItem
	pop hl
	ccf
	ret nc
	bit 0,(ix+13)
	ret z
	scf
	ret
*/

txt1f04	ld a,(hl)	; 1f,4,n,x,<adr>	if var n == x
	inc hl
	call getVar
	cp (hl)
	inc hl
	scf
	ret z
	ccf
	ret
	
txt1f05	ld a,(hl)	; 1f,5,n,m,<adr>	if var n == var m
	inc hl
	call getVar
	ld c,a
	ld a,(hl)
	inc hl
	call getVar
t1f05a	cp c
	scf
	ret z
	ccf
	ret

txt1f06	ld a,(hl)	; 1f,6,n,x,<adr>	if var n < x
	inc hl
	call getVar
	cp (hl)
	inc hl
	ret
	
txt1f07	ld a,(hl)	; 1f,7,n,m,<adr>	if var n < var m
	inc hl
	call getVar
	ld c,a
	ld a,(hl)
	inc hl
	call getVar
	ld b,a
	ld a,c
	cp b
	ret

txt1f08	ld a,(hl)	; 1f,8,n,x,<adr>	if var n != x
	inc hl
	call getVar
	cp (hl)
	inc hl
	ret z
	scf
	ret

txt1f09	ld a,(hl)	; 1f,9,n,m,<adr>	if var n != var m
	inc hl
	call getVar
	ld c,a
	ld a,(hl)
	inc hl
	call getVar
	cp c
	ret z
	scf
	ret

txt1f0a	push hl		; 1f,0a,id,<adr>		if ahead is person id
	call scanNPC
t1f0aa	pop hl
	ld a,(hl)
	inc hl
	cp 0xff
	jr nz,t1f05a
	ld a,c
	add a,1
	ccf		; NC (false) if C==255
	ret
	
txt1f0b	push hl		; 1f,0b,id,<adr>		if ahead is element id
	call scanELM
	jr t1f0aa

txt1f0c	ld c,(hl)	; 1f,0c,id,<adr>		if NPC.id have animation
	inc hl
	call findNPC
	ret nc		; not found : false
	ld a,(ix+7)
	and a
	ret z		; no animation : false
	scf		; true
	ret

/*
txt1f0d	ld c,(hl)	; 1f,0d,id,n,<adr>		if in bag item.id count >= n
	inc hl
	push hl
	call findItem
	jr c,t1f0da
	bit 0,(ix+13)
	jr z,t1f0da
	ld a,(ix+10)
	pop hl
	cp (hl)		; C - less, NC - great.or.equal
	inc hl
	ccf		; NC - less (false), C - >= (true)
	ret
t1f0da	pop hl
	inc hl
	and a
	ret
*/

txt1f0e	call getRnd	; 1f,0e,n,<adr>			if rnd < n
	cp (hl)
	inc hl
	ret

txt1f0f	ld a,(hl)	; 1f,0f,n,msk,<adr>		if var[n] & msk != 0
	inc hl
	call getVar
	and (hl)
	inc hl
	ret z		; NC : false (var & mask == 0)
	scf
	ret

txt1f10	push hl		; 1f,10,msk,<adr>		 if (RND & msk != 0)
	call getRnd
	pop hl
	and (hl)
	inc hl
	ret z
	scf
	ret
	
txt1f11	ld c,(hl)	; 1f,11,id,<adr>		if have item id
	inc hl
	push hl
	call findItem
	pop hl
	ccf
	ret nc
	ld a,(ix+13)
	rra
	ret

txt1f12	ld c,(hl)	; 1f,12,id,<adr>		if have magic id
	inc hl
	push hl
	call magic.findMagic
	inc hl
	ld a,(hl)
	pop hl
	ccf
	ret nc
	rra
	ret
	
txt1f13	ld c,(hl)	; 1f,13,id,<adr>		if have potion id
	inc hl
	push hl
	call potion.find
	inc hl
	inc hl
	ld a,(hl)
	pop hl
	ccf
	ret nc
	and a
	ret z
	scf
	ret
	
txt1f14	ld a,(battle.bFlag)	; 1f,14,<adr>		if turn canceled
	rra
	ret

;---------

dLine	db 4
; 0,1,2 : line of text in dialog box
; 3 : wait keypress, clear window
; 4 : no dialog box

wPos	dw 0	; x,y

	ENDMODULE