
muzOn	ld a,0xa7
	ld (muzFlag),a
	ret

muzOff	ld a,0x37
	ld (muzFlag),a
	jr mMute

muzGSwitch
	ld a,(mzFlag)
	xor 0x90
	ld (mzFlag),a
	cp 0x37
	ret nz
mMute	ld a,muzBank
	call bankSR
	jp p1.muzMute

setMuz	ld a,(curMuz)
	cp c
	ret z
	ld a,c
	ld (curMuz),a
	ld a,muzBank
	call bankSR
	ld b,0
	ld hl,(0xc001)
	LDHL
	add hl,bc
	add hl,bc
	LDHL
	call p1.muzInit
	call oregz
	ei
	ret
	
curMuz	db 0xff
	
; SFX

setSysSFX
	ld hl,sysSFX
	jr ssfxHL

; set SFX, C=nr

setSFX	ld a,muzBank
	call bankSR
	ld hl,(0xc001)
	inc hl
	inc hl
	LDHL
ssfxHL	ld a,(sfxFlag)
	cp 0x37
	ret z
	ld b,0
	add hl,bc
	add hl,bc
	add hl,bc
	add hl,bc
	add hl,bc
	ld a,(hl)	; note
	cp 96
	ret nc
	inc hl
	ld c,a
	call ldDE	; smp.adr
	LDHL		; orn.adr
	ld a,d
	or e
	ret z
	ld a,c
	ld (smpNote),a
	ld a,(de)
	inc de
	ld (smpCnt),a
	ld (smpAdr),de
	ld a,h
	or l
	jr z,ssfx0E
	ld a,(hl)
	inc hl
	ld (ornAdr),hl
	ADDA h,l
	ld (ornCyc),hl
ssfx0E	ld hl,0
	ld (smpShft),hl
	ret

; mix current played SFX to regBuf

playSFX	ld a,(smpCnt)
	sub 1
	ret c
	ld (smpCnt),a
	ret z
;	ld a,(smpNote)
;	call getTone
;	ex de,hl
	ld de,(smpShft)
	ld hl,(smpAdr)
	call ldBC		; +0,1:tone shift
	ex de,hl
;	ld hl,(smpTone)
	add hl,bc
;	ld (regBuf + 0),hl	; 0,1 : tone A
	ex de,hl
	ld a,(hl)		; +2: b0..4 = noize, b765=TNE (1:off)
	and 0x1f
	ld (regBuf + 6),a	; 6 : noize
	ld a,(regBuf + 7)
	and %11110110
	ld c,a
	ld a,(hl)
	rla		; T
	jr nc,spl_T
	set 0,c
spl_T	rla		; N
	jr nc,spl_N
	set 3,c
spl_N	ld a,c
	ld (regBuf+7),a
	inc hl
	ld a,(hl)		; +3: b0..3 = volume, b5:ts
	and 0x0f
	ld (regBuf + 8),a	; 8 : volume A
	ld a,(hl)
	and 0x20
	jr z,sply01
	ld (smpShft),de
sply01	inc hl
	ld (smpAdr),hl
	call getTone
	add hl,de
	ld (regBuf+0),hl
	ret

smpCnt	db 0
smpAdr	dw 0
smpNote	db 0
smpShft	dw 0
smpNoiz	db 0

ornCyc	dw 0
ornAdr	dw 0

; play
	
playMuz	call mzBank
	ld hl,zReg
mzFlag	and a		; muzSwitch trig - global on/off
	jr c,pSmp
muzFlag	scf		; muzSwitch on/off - script control
	call nc,p1.muzPlay	; don't out regz. return HL = p1.ayregs
pSmp	ld de,regBuf	; copy player regz to internal buf
	ld bc,14
	ldir
sfxFlag	and a		; mix SFX (if any) to internal buf
	call nc,playSFX
	ld hl,regBuf	; out regz internal buf
oregz	xor a
	ld de,#ffbf
	ld bc,#fffd
lout	out (c),a
	ld b,e
	outi
	ld b,d
	inc a
	cp 13
	jr nz,lout
	out (c),a
	ld a,(hl)
	and a
	ret m
	ld b,e
	out (c),a
	ret
        
getTone	ld hl,(ornAdr)
	ld a,h
	or l
	ld a,(smpNote)
	jr z,gton1
	ld c,(hl)
	inc hl
	cp 0x80
	jr nz,gton0
	ld hl,(ornCyc)
	ld c,(hl)
	inc hl
gton0	ld (ornAdr),hl
	add a,c
gton1	sub 96
	jr nc,gton1
	add a,96
	add a,a
	ld hl,frqTab
	ADDA h,l
	LDHL
	ret

sysSFX	SFXDATA 255,smpMsg,0	; note,smpAdr,ornAdr

smpMsg	incbin "L7engine/message.C7.smp"

frqTab	incbin "L7engine/pt3FrqTab.bin"

zReg	ds 14
regBuf	ds 14