; battles 

; battle : battleID,<battle.adr>
; data : dw main.script, start.script, lose.script, win.script
;	{FIGHTER id,x,y,<data.adr>,flag},255	(x=255:don't change x,y)
; fighter : <act.tab.adr>,{atk,def}x4

batlTable
	DBW 0,batl00	; firecat
	DBW 1,batl01	; 3 spiders
	DBW 2,batl02	; strong spider
	DBW 3,batl03	; eyes-demon
	DBW 4,batl04	; troll
	DBW 5,batl05	; dark wizard
	DBW 6,batl06	; golem
	DBW 7,batl07	; bugs
	DBW 100,batl100	; final boss
	db 255		; 255 : end

bMainScript
	tBattleStart		; run start script
	tBattleInfoWindow 1
bms01	tBattleTurn		; turn : dec potion duration, add fxTURN affects
bms02	tBattleCancel 0		; 255 : test bit, set if turn canceled
	tMenu 1,1,0,0,bMenu	; battle menu
	tIfCancel bms02		; if turn canceled, show menu again
	tIfBattleWin bmsWin	; if battle win
	tPickEnemy 255		; pick random live enemy
	tPickAlly 254
	tBattleScript 255,bsATK	; enemy attacks hero
	tIfBattleLose bmsLose	; if battle lose
	tJump bms01		; show menu again
bmsWin	tBattleInfoWindow 0	; win
	tMuzPlay 6
	tMuzSwitch 1
	tBattleScript 0,bsWIN	; run hero win script
	tBattleWin		; run battle win script
	tMuzPlay 1		; set muz 1 (main theme)
	tMuzSwitch 1		; turn music on
	tEnd
bmsLose	tBattleInfoWindow 0	; lose
	tMuzSwitch 0
	tBattleScript 0,bsDTH	; run hero lose script
	tBattleLose		; run battle lose script
	tMuzPlay 1
	tMuzSwitch 1
	tEnd

bMenu	mPunkt 0,mmAtk,0,bAttack
	mPunkt 0,mmMag,0,bMagic
	mPunkt 0,mmPot,0,bPotion
	db 0xff
	
mmAtk	db MSG0011,0
mmMag	db MSG0012,0
mmPot	db MSG0013,0

bAttack	tSelectEnemy 255,m01ex	; select enemy, exit if cancel
	tAttack 0,255,0		; calc damage of std.atack id:0(hero) to id:255(selected enemy)
	tBattleScript 0,bsATK	; set animation : hero,atack
	tDelHP 255,255		; decrease id:255(selected enemy) HP to 255(calculated damage), show number
	tWaitNPC 0		; wait till end of hero animation
	tBattleScript 0,bsIDL	; set idle animation to hero
	tCheckNPC 255,1,ascrE	; if selected enemy is alive, exit
	tBattleScript 255,bsDTH	; set death anim to selected enemy
	tWaitNPC 255
ascrE	tEnd

bMagic	tMagicMenu
bmEnd	tBattleScript 0,bsIDL
	tEnd
	
bPotion	tPotionMenu
	tJump bmEnd
	
; battle 00 : firecat

batl00	dw bMainScript,b00start,0,b00win
	FIGHTER 0,255,0,0,2
	FIGHTER idFirecat,10,10,fcatData,0
	db 255

b00start
	tMuzPlay 2
	tNpcAni idFirecat,fcatStart
	tWaitNPC idFirecat
fcIdle	tNpcAni idFirecat,fcatIdle
	tEnd

b00win	tSetBit 100
	tInfoProgress 0,10,5
	tAddMagic 1
	tInfoText MSGLM01
	tMoveNPC idMayor,16,17,3
	tMoveNPC idMonk,15,27,4
	tZoneOff 0
zBEnd	tWaitNPC 0
	tEnd
	
fcatData
	dw fcatAT			; script tab adr
	db 5,200,20,128,0,128,0,128	; atk/def x 4

fcatAT	DBW bsIDL,fcIdle
	DBW bsATK,fcAtk
	DBW bsDTH,fcDeath
	db 0

fcAtk	tNpcAni idFirecat,fcatAtack
stdAtk	tAttack 255,254,0	; calc damage for attack picked Enemy (255) to picked Ally (254)
	tWaitNPC 255		; wait for chosen NPC (255) animation end
	tDelHP 254,255		; decrease ally HP (255 : calculated damage)
	tBattleScript 255,bsIDL	; go idle for chosen NPC (255)
	tEnd
	
fcDeath	tNpcAni idFirecat,fcatDeath
	tWaitNPC idFirecat
	tEnd

; battle 01 : black spiders

batl01	dw bMainScript,b01start,b01lose,b01win
	FIGHTER 0,255,0,0,2
	FIGHTER idSpiderA,40,7,spdrData,0
	FIGHTER idSpiderB,40,6,spdrData,0
	FIGHTER idSpiderC,40,7,spdrData,0
	db 255

b01start
	tMuzSwitch 0
	tExtend talk03z
	tDialogOff
	tMoveNPC idSpiderA,22,9,7
	tMoveNPC idSpiderB,22,14,6
	tMoveNPC idSpiderC,22,19,7
	tJump bxStart

b01lose	tMoveNPC idSpiderA,22,40,0	; move spiders to start position
	tMoveNPC idSpiderB,22,43,0
	tMoveNPC idSpiderC,22,46,0
	tEnd
	
b01win	tSetBit 101
	tInfoProgress 0,5,2
	tZoneOff 2
	tJump zBEnd

spdrData
	dw spdrAT
;	db 30,20
	db 30,96,0,0,0,0,0,0

spdrAT	DBW bsIDL,spIdle
	DBW bsATK,spAtk
	DBW bsDTH,spDead
	db 255

spIdle	tNpcAni 255,spdrIdle
	tEnd
	
spAtk	tNpcAni 255,spdrAtack
	tJump stdAtk
	
spDead	tNpcAni 255,spdrDeath
	tEnd

; 02 : strong spider in cave

batl02	dw bMainScript,bxStart,0,b02win
	FIGHTER 0,255,0,0,2
	FIGHTER idSpiderD,255,0,strongSpiderData,0
	db 255

b02win	tSetBit 102
	tInfoProgress 0,5,3
	tZoneOff 6
	tJump zBEnd
	
strongSpiderData
	dw spdrAT
	db 30,200,0,0,0,0,0,0

; 03 : eye demon

batl03	dw bMainScript,b03start,0,b03win
	FIGHTER 0,255,0,0,2
	FIGHTER idManyeye,255,0,eyeDemonData,0
	FIGHTER idEyeA,255,0,eyesData,1		; b0:can't attack
	FIGHTER idEyeB,255,0,eyesData,1
	FIGHTER idEyeC,255,0,eyesData,1
	FIGHTER idEyeD,255,0,eyesData,1
	db 255
	
b03start
	tMuzSwitch 0
	tIfSet 200,b03st01
	tExtend talk07e
	tDialogOff
	tNpcAni idManyeye,eyerStart
	tWaitNPC idManyeye
	tNpcAni idManyeye,eyerIdle
	tSetBit 200
b03st01	tMoveNPC idEyeA,33,24,5
	tMoveNPC idEyeB,33,26,6
	tMoveNPC idEyeC,33,18,6
	tMoveNPC idEyeD,33,20,5
bxStart	tMuzPlay 2
	tMuzSwitch 1
	tEnd

b03win	tMoveNPC idMaster,24,22,3
	tMoveNPC idKnight,42,15,5
	tSetBit 103
	tInfoProgress 0,10,5
	tAddMagic 2
	tInfoText MSGLM02
	tZoneOff 7
	tJump zBEnd

eyeDemonData
	dw eyerAT
;	db 100,10
	db 20,255,0,196,0,255,0,255		; 75% fire; 100% other; phys.atk 20

eyesData
	dw eyesAT
;	db 1,1
	ds 8

eyerAT	DBW bsIDL,edIdle
	DBW bsATK,edAtk
	DBW bsDTH,edDeath
	db 255
	
edIdle	tIfRes 200,eidl0
	tNpcAni idManyeye,eyerIdle
eidl0	tEnd

edAtk	tNpcAni idManyeye,eyerAttack
	tJump stdAtk

edDeath	tNpcAni idManyeye,eyerDeath
	tWaitNPC idManyeye
	tBattleCurrent 255,idEyeA
	tCall eyeDead
	tBattleCurrent 255,idEyeB
	tCall eyeDead
	tBattleCurrent 255,idEyeC
	tCall eyeDead
	tBattleCurrent 255,idEyeD
eyeDead	tCheckNPC 255,0,ededX
eded01	tBattleSetHP 255,0
	tNpcAni 255,eyeDeath
	tWaitNPC 255
ededX	tEnd
	
eyesAT	DBW bsIDL,eyIdle
	DBW bsDTH,eyDeath
	db 255
	
eyIdle	tNpcAni 255,eyeAnim
	tEnd

eyDeath	tCall eded01			; eye dead
	tDelHP idManyeye,20		; delete 20 HP from demon
	tCheckNPC idManyeye,1,edsX	; if demon still alive
	tBattleScript idManyeye,bsDTH	; death to demon
	tWaitNPC idManyeye
edsX	tEnd

; 04 : troll

batl04	dw bMainScript,bxStart,0,b04win
	FIGHTER 0,255,0,0,2
	FIGHTER idTroll,255,0,trollData,0
	db 255
	
b04win	tSetBit 104
	tPutItem 26,40,18,5
	tInfoProgress 0,15,5
	tZoneOff 9
	tJump zBEnd

trollData
	dw trollAT
	db 50,200,0,128,0,128,0,128

trollAT	DBW bsIDL,trIdle
	DBW bsATK,trAtk
	DBW bsDTH,trDeath
	db 255

trIdle	tNpcAni idTroll,trollIdle
	tEnd

trAtk	tNpcAni idTroll,trollAttack
	tJump stdAtk

trDeath	tNpcAni idTroll,trollDeath
	tEnd

; 05 : dark wizard

batl05	dw bMainScript,b05start,b05lose,b05win
	FIGHTER 0,255,0,0,2
	FIGHTER idWizard,255,0,wizData,0
	db 255

b05start
	tMuzSwitch 0
	tNpcAni idWizard,wizStart
	tWaitNPC idWizard
	tNpcAni idWizard,wizIdle
	tIfSet 201,b05s_01
	tExtend talkWZa
	tSetBit 201
	tJump b05s_02
b05s_01	tExtend talkWZb
b05s_02	tDialogOff
	tJump bxStart

b05lose	tNpcAni idWizard,ani111
	tEnd
	
b05win	tSetBit 105
	tInfoProgress 0,10,10
	tAddMagic 4
	tInfoText MSGLM04
	tZoneOff 10
	tJump zBEnd

wizData
	dw wizAT
;	db 150,0
	db 0,160,0,160,0,160,20,248

wizAT	DBW bsIDL,wzIdle
	DBW bsATK,wzAtk
	DBW bsDTH,wzDeath
	db 255

wzIdle	tNpcAni idWizard,wizIdle
	tEnd

wzAtk	tNpcAni idWizard,wizAttack
	tIfRndLess 50,wzHeal
	tVarSet 251,0
	tAttack 255,254,0
	tIfRndLess 128,watk02
watk01	tMapAni 105,ani105a
	tWaitElem 105
	tPause 10
	tVarAdd 251,1
	tIfVarLess 251,3,watk01
	tJump watk03
watk02	tMapAni 105,ani105b
	tWaitElem 105
	tPause 10
	tVarAdd 251,1
	tIfVarLess 251,3,watk02
watk03	tWaitNPC 255
	tDelHP 254,255
	tBattleScript 255,bsIDL
	tEnd
	
wzHeal	tWaitNPC idWizard
	tRaiseHP idWizard,64		; healing +25%
	tBattleScript idWizard,bsIDL
	tEnd

wzDeath	tNpcAni idWizard,wizDeath
	tEnd

; 06 : golem

batl06	dw bMainScript,b06start,b06lose,b06win
	FIGHTER 0,255,0,0,2
	FIGHTER idGolem,255,0,golemData,0
	FIGHTER idHelperA,40,40,hlpData,0
	FIGHTER idHelperB,43,40,hlpData,0
	db 255

b06start
	tCall bxStart
	tResBit 150
	tResBit 151
	tResBit 152
b06lose	tMoveNPC idHelperA,48,40,40
	tMoveNPC idHelperB,48,43,40
	tEnd

b06win	tSetBit 106
	tInfoProgress 0,15,10
	tAddMagic 3
	tInfoText MSGLM03
	tZoneOff 11
	tMoveNPC idTrader,42,27,6
	tIfSet 49,z11a			; if you give book to knight
	tMoveNPC idKnight,42,40,40	; if not - knight go away
	tSetBit 59
	tEnd
z11a	tMoveNPC idKnight,49,19,2	; move knight to secret cave
	tMapSpr 70,as70o	; set key
	tElemOff 70
	tMapSpr 71,as71o	; open door
	tMapSpr 82,as14o	; open & off chest
	tElemOff 82
	tMoveNPC idBandit,21,40,40	; remove bandit
	tJump zBEnd

golemData
	dw golemAT
;	db 150,0
	db 40,128,0,128,0,128,0,128
	
golemAT	DBW bsIDL,glIdle
	DBW bsATK,glAtk
	DBW bsDTH,glDead
	db 255
	
glIdle	tNpcAni idGolem,golemIdle
	tEnd

glAtk	tIfSet 150,gatk01
	tIfBattleHPLess idGolem,100,gatkS1	; if golem HP < 100 && bit150 = 0, summon helper 1
gatk01	tIfSet 151,gatk02
	tIfBattleHPLess idGolem,50,gatkS2	; if golem HP < 50 && bit151 = 0, summon helper 2
gatk02	tNpcAni idGolem,golemAtk		; else : common attack
	tJump stdAtk
gatkS1	tBattleCurrent 255,idHelperA
	tMoveNPC idHelperA,48,11,7
	tSetBit 150
gtks01	tBattleScript 255,bsSHW
	tWaitNPC 255
	tBattleScript 255,bsIDL
	tBattleSetHP 255,50
	tEnd
gatkS2	tBattleCurrent 255,idHelperB
	tMoveNPC idHelperB,48,18,7
	tSetBit 151
	tJump gtks01
	
glDead	tNpcAni idGolem,golemDead
	tEnd

hlpData	dw hlpAT
;	db 0,0			; hp = 0 : doesn't show @ start
	db 0,128,0,64,50,255,0,0
	
hlpAT	DBW bsIDL,hlpIdle
	DBW bsDTH,hlpDead
	DBW bsATK,hlpAtk
	DBW bsSHW,hlpApr
	db 255
	
hlpIdle	tNpcAni 255,helpIdle
	tEnd
	
hlpApr	tNpcAni 255,helpAppear
	tEnd
	
hlpDead	tNpcAni 255,helpDead
	tEnd
	
hlpAtk	tAttack 255,254,0
	tNpcAni 255,helpAttack
	tPause 20
	tMapAni 106,ani106
	tWaitElem 106
	tNpcAni 255,helpIdle
	tJump stdAtk

; 07 : bugs

batl07	dw bMainScript,bxStart,0,b07win
	FIGHTER 0,255,0,0,2
	FIGHTER idBug1,255,0,bugData,0
	FIGHTER idBug2,255,0,bugData,0
	FIGHTER idBug3,255,0,bugData,0
	db 0xff
	
b07win	tSetBit 107
	tInfoProgress 0,10,3
	tZoneOff 14
	tJump zBEnd
	
bugData	dw bugAT
;	db 50,0
	db 10,128,10,128,10,128,0,0
	
bugAT	DBW bsIDL,bgIdle		; TODO
	DBW bsATK,bgAttack
	DBW bsDTH,bgDead
	db 0xff

bgIdle	tNpcAni 255,bugIdle
	tEnd
	
bgAttack
	tNpcAni 255,bugAttack
	tJump stdAtk

bgDead	tNpcAni 255,bugDead
	tEnd

; FINAL DEMON

batl100	dw bMainScript,b100st,b100los,b100win
	FIGHTER 0,255,0,0,2
	FIGHTER idDemon,255,0,demData,0
	db 0xff

b100st	tMuzPlay 3
	tMuzSwitch 1
	tNpcSpr idDemon,demEye1
	tNpcAni	idDemArmR,aniRArmDown
	tWaitNPC idDemArmR
	tNpcAni idDemArmL,aniLArmDown
	tWaitNPC idDemArmL
	tVarSet 6,0
	tSetAttack idDemon,demStdAtk
	tSetDefence idDemon,demStdDef
	tSetActions 0,dHeroAT
	tNpcAni idDemon,deyeAni
	tEnd
	
b100win	tZoneOff 16
	tMuzSwitch 0
	tInfoText MSG0087
	tAnimation 0
	tFillAtrs 2
	tPause 50
	tGCls 0x47
	tMuzPlay 4
	tMuzSwitch 1
	tInitViewport 0,8,32,8
	tInitColor fColors
	tFillAtrs 0
	tDepack finDn,0x5000
	tExec swDown
	tFillAtrs 7
	tExtend finalScript
	tJump gameScript

finDn	incbin "bin/finaldn.pak"	; final up

fColors	db 0,0,0,0,0,0,0,0x30

swDown	ld hl,0x5000
	ld de,0x47e0
swdn01	dup 31
	 ldi
	edup
	ld a,(hl)
	ld (de),a
	inc h
	dec d
	dup 31
	 ldd
	edup
	ld a,(hl)
	ld (de),a
	inc h
	dec d
	ld a,h
	and 7
	jp nz,swdn01
	ld d,0x47
	ld h,0x50
	ld a,e
	sub 32
	ld e,a
	ld a,l
	add a,32
	ld l,a
	jp nc,swdn01
	ret

b100los	tNpcAni idDemon,aOff
	tNpcAni idDemArmR,aOff
	tNpcAni idDemArmL,aOff
	
	tIfHavePotion 0,dblos1		; restore berries, if you don't have this type and potions
	tIfHaveItem 12,dblos1
	tMoveElem 200,2,16,8
dblos1	tIfHavePotion 1,dblos2
	tIfHaveItem 13,dblos2
	tMoveElem 201,9,20,13
dblos2	tIfHavePotion 2,dblos3
	tIfHaveItem 14,dblos3
	tMoveElem 202,8,26,16
dblos3	tIfHavePotion 3,dblos4
	tIfHaveItem 15,dblos4
	tMoveElem 203,23,14,4
dblos4
	tEnd
	
aOff	DBW 1,empty11
	aEnd

demData	dw demAT
;	db 250,0
	db 30,196,0,128,0,128,0,128
	
demStdAtk db 30,3,3,3
demFirAtk db 10,20,3,3
demLgtAtk db 10,3,20,3
demDrkAtk db 10,3,3,20

demStdDef db 224,160,160,160
demFirDef db 224,255,128,128
demLgtDef db 224,128,255,128
demDrkDef db 224,128,128,255

demAT	DBW bsATK,demonATK
	DBW bsDTH,demonDTH
	db 0xff
	
demonATK
	tCall demBeat
	tCheckNPC 0,0,datkN
	tVarAdd 6,1		; change atk/def type each 3 turns
	tIfVarLess 6,3,datkN
	tVarSet 6,0
	tCall dChangeAtk
	tCall dChangeDef
	tWaitNPC idDemArmR
	tWaitNPC idDemArmL
datkN	tEnd

demBeat	tAttack 255,254,0
	tNpcAni idDemArmR,raAttack
	tWaitNPC idDemArmR
	tDelHP 254,255
	tEnd
	
dChangeAtk
	tIfRndLess 64,dAtkPhys
	tIfRndLess 83,dAtkFire
	tIfRndLess 128,dAtkLgtn
	tSetAttack idDemon,demDrkAtk
	tNpcAni idDemArmR,raDark
	tEnd
dAtkFire tSetAttack idDemon,demFirAtk
	tNpcAni idDemArmR,raFire
	tEnd
dAtkLgtn tSetAttack idDemon,demLgtAtk
	tNpcAni idDemArmR,raLght
	tEnd
dAtkPhys tSetAttack idDemon,demStdAtk
	tNpcAni idDemArmR,raForce
	tEnd

dChangeDef
	tIfRndLess 83,dDefFire
	tIfRndLess 128,dDefLght
	tSetDefence idDemon,demDrkDef
	tNpcAni idDemArmL,laDark
	tEnd
dDefFire tSetDefence idDemon,demFirDef
	tNpcAni idDemArmL,laFire
	tEnd
dDefLght tSetDefence idDemon,demLgtDef
	tNpcAni idDemArmL,laLght
	tEnd

demonDTH
	tNpcAni idDemon,deyeDie
	tNpcAni idDemArmL,darmlDie
	tNpcAni idDemArmR,darmrDie
	tEnd

dHeroAT	DBW bsIDL,hbaIdle		; changed heroAT (bsATK)
	DBW bsATK,hdemAtk
	DBW bsWIN,hbaWin
	DBW bsDTH,hbaLose
	DBW bsPOT,hbaPoti
	DBW bsMAG,hbaMagi
	db 255

hdemAtk	tNpcAni 0,aniHeroAtkDemon
	tNpcAni idDemArmL,laDefence
	tWaitNPC idDemArmL
	tEnd

; === hero data

heroAT	DBW bsIDL,hbaIdle
	DBW bsATK,hbaAtk
	DBW bsWIN,hbaWin
	DBW bsDTH,hbaLose
	DBW bsPOT,hbaPoti
	DBW bsMAG,hbaMagi
	db 255
	
hbaIdle	tNpcAni 0,faniHeroIdle
	tEnd
	
hbaAtk	tNpcAni 0,faniHeroAtack
	tEnd
	
hbaWin	tNpcAni 0,faniHeroWin
	tEnd
	
hbaLose	tNpcAni 0,faniHeroLose
	tEnd
	
hbaPoti	tNpcAni 0,faniHeroDrink
	tEnd
	
hbaMagi	tNpcAni 0,faniHeroSpell
	tEnd

faniHeroIdle
	aIfDirNot dirNorth,fhi01
	DBW 1,herou0
	aEnd
fhi01	aIfDirNot dirEast,fhi02
	DBW 1,heror0
	aEnd
fhi02	aIfDirNot dirSouth,fhi03
	DBW 1,herod0
	aEnd
fhi03	DBW 1,herol0
	aEnd

faniHeroAtack
	aMoveTo posVIC,posVIC
	aShift 0,1
fha1	aCycle 3
	aPlaySFX 0
	DBW 10,herou1
	DBW 7,hatk1
	DBW 10,herou2
	aEndCycle
	aMoveTo posATK,posATK	; to fatkIP
	DBW 1,herou0
	aJump faniHeroIdle

aniHeroAtkDemon
	aMoveTo 15,6
	aJump fha1
	
faniHeroLose
	aSetBit 255
	aMoveDir dirSouth
	dup 5
	 DBW 20,hlos0
	 DBW 20,empty11
	edup
	aResBit 255
	aEnd

faniHeroWin
	aSetBit 255
	DBW 20,hwin0
	DBW 5,hwin1
	DBW 20,hwin2
	DBW 5,hwin1
	DBW 20,hwin0
	aSetDir dirSouth
	DBW 1,herod0
	aResBit 255
	aEnd

faniHeroSpell
	aCycle 3
	 DBW 5,herol0
	 DBW 5,herou0
	 DBW 5,heror0
	 DBW 5,herod0
	aEndCycle
	aJump faniHeroIdle
	
faniHeroDrink
	aSetBit 255
	DBW 25,hdrink
	aResBit 255
	aJump faniHeroIdle