#!/bin/sh

if [ ! -e obj ]; then
	mkdir obj
fi

cd intro
sjasmplus intro.asm || exit
mhmt -hst -zxh intro.bin ../obj/intro.hr1

cd ..
sjasmplus main.asm || exit
cp ./bin/map.bin ./obj/page4.bin

cd obj
mhmt -hst -zxh engine.bin engine.hr1
mhmt -hst -zxh gfx.bin gfx.hr1
mhmt -hst -zxh page1.bin page1.hr1
mhmt -hst -zxh page3.bin page3.hr1
mv page4.bin page4.hr1			# map : doesn't packed
mhmt -hst -zxh page7.bin page7.hr1

cd ../loader
sjasmplus loader.asm || exit
mv boot.bas ../obj/
mv Wanderer.bas ../obj/
mv loader.COD ../obj/
cp dehr1.6000.bin ../obj

INAM="Wanderers.scl"
TNAM="Wanderers.tap"

cd ../obj
mctrd new ${INAM}
mctrd add boot.bas ${INAM} -b -a 1
mctrd add dehr1.6000.bin ${INAM}
mctrd add intro.hr1 ${INAM}
mctrd add page1.hr1 ${INAM}
mctrd add page3.hr1 ${INAM}
mctrd add page4.hr1 ${INAM}
mctrd add page7.hr1 ${INAM}
mctrd add engine.hr1 ${INAM}
mctrd add gfx.hr1 ${INAM}

mctrd new ${TNAM}
mctrd add -b -a 10 Wanderer.bas ${TNAM}
mctrd add loader.COD ${TNAM}
mctrd add -n intro.hr1 ${TNAM}
mctrd add -n page1.hr1 ${TNAM}
mctrd add -n page3.hr1 ${TNAM}
mctrd add -n page4.hr1 ${TNAM}
mctrd add -n page7.hr1 ${TNAM}
mctrd add -n engine.hr1 ${TNAM}
mctrd add -n gfx.hr1 ${TNAM}

mv ${INAM} ../
mv ${TNAM} ../
cd ..
rm -r ./obj