; game script (C000,scrBank0)

scriptAdr dw gameScript		; main script
npcTabAdr dw npcTable		; npc
elmTabAdr dw elmTable		; elements
itemTabAdr dw itemTable		; items
doorTabAdr dw doorTable		; doors
zoneTabAdr dw zoneTable		; zones
batlTabAdr dw batlTable		; battles
magTabAdr dw magicTable		; magic
potTabAdr dw potionTable	; potions
effTabAdr dw effectTable	; effects
eqpTabAdr dw equipTable		; equipment
cftTabAdr dw craftTable		; craft
tilTabAdr dw tileSetTable	; tilesets

; game main script

gColors	db 0,0,0,0,0,0,0,6
gLayMap	db 0,1,2,3,4,5,6,7

gameScript
	tInitLay gLayMap
	tAnimation 0
	tBorder 0
	tMuzPlay 0			; play muz 0 (title)
	tMuzSwitch 1			; turn muz on
	tExtend oTitle			; unpak title to screen
	tWaitKey			; wait keypress
	tACls 7				; atribute cls

	tMuzPlay 1			; play muz 1 (ingame)
	tInitLayers %01000011,%00001010	; set not-masked layers (1,2,7) & impassable layers (2,4)
	tInitColor gColors		; set layers colors
	tInitViewport 1,1,30,19		; set viewport
	tInitMap %00100011		; set layers in map (1,2,6)
	tInitHero 50,20,heroAT		; init start hero parameters (hp,mp,ATtable)
	tInitData			; init tables data
	tAnimation 1
	tExtend oSkin			; draw skin
	tDrawBag			; draw items
	tTurnL7 1
	tSetMap 255			; set hero map

;	tCall z18scr
;	tAddPotion 0
;	tAddMagic 1
;	tAddEquip eAmulet,2
;	tAddItem 6
;	tMoveNPC idMonk,15,27,4
/*
	tAddItem 1
	tMoveNPC idBandit,21,19,4
	tCall z03scr
	tCall afct13a
*/
;	tMoveNPC 0,34,5,5
;	tMoveNPC idMaster,34,10,5

gsLoop	tHalt			; main cycle : scan key & exec function
	tKeyScan mKeyTab
	tJump gsLoop

mKeyTab	dw 0x01fd,gsDown	; A
	dw 0x01fb,gsUp		; Q
	dw 0x01df,gsRight	; P
	dw 0x02df,gsLeft	; O

	dw 0x10ef,gsLeft	; sinclair R
	dw 0x08ef,gsRight
	dw 0x04ef,gsDown
	dw 0x02ef,gsUp

;	dw 0x10f7,gsLeft	; cursor
;	dw 0x10ef,gsDown
;	dw 0x08ef,gsUp
;	dw 0x04ef,gsRight

	dw 0x017f,gsMenu	; Space : menu
	dw 0x01ef,gsMenu	; 0 : menu
	dw 0x02fe,gsZ		; Z : shift items left
	dw 0x04fe,gsX		; X : shift items right
	dw 0x08fe,gsC		; C : show item name
	dw 0x04fb,gsE		; E : talk/affect
	dw 0x02fb,gsPickUp	; W : pick up
	dw 0x02fd,gsGive	; S : give
	dw 0x04fd,gsUse		; D : use
	dw 0x04df,gsEquip	; I : equipment

	;dw 0x1cbf,dbgMove	; DEBUG: HJK - move to demon
;	dw 0x1cdf,b100win	; DEBUG: YUI - final
	db 0

dbgMove	;tMoveNPC 0,50,15,15	; to demon
	;tMoveNPC 0,33,13,11	; to eye-demon
	;tMoveNPC 0,46,12,15	; wizard
	;tMoveNPC 0,48,13,14	; crystal cave
	;tJump b100win
	;tAddMagic 2
	;tAddEquip eArmor,3
	;tAddEquip eSword,3
	;tAddEquip eShield,3
	;tAddEquip eAmulet,1
	tEnd

gsDown	tNpcAni 0,c00dn		; move down
gsd00	tWaitNPC 0
	tZoneScan gsd00
	tEnd

gsUp	tNpcAni 0,c00up		; move up
	tJump gsd00

gsLeft	tNpcAni 0,c00lf		; move left
	tJump gsd00

gsRight	tNpcAni 0,c00rg		; move right
	tJump gsd00

gsZ	tRotateBag 0		; shift items
	tEnd

gsX	tRotateBag 1
	tEnd

gsC	tShowItemName		; show current item name
	tEnd

gsE	tIfNPC 255,gsTalk	; talk / affect
	tJump gsAffect

gsMenu	tMenu 255,255,0,0,dMainMenu
gsBack	tEnd

dMainMenu
	mText mmHead
	mPunkt 0,mmBack,0,gsBack
	mPunkt 1,mmTalk,0,gsTalk
	mPunkt 5,mmGive,0,gsGive
	mPunkt 2,mmPick,0,gsPickUp
	mPunkt 3,mmUse,0,gsUse
	mPunkt 7,mmAfct,0,gsAffect
	mPunkt 0,mmEquip,0,gsEquip
	mPunktBit 21,mmCraft,0,gsCraft
	db 0xff

mmHead	db MSG0000,0
mmBack	db "..",0
mmTalk	db MSG0001,0
mmGive	db MSG0002,0
mmPick	db MSG0003,0
mmUse	db MSG0004,0
mmAfct	db MSG0005,0
mmEquip	db MSG0006,0
mmCraft	db MSG0007,0

gsTalk	tActionTalk talkTable	; talk npc
	tEnd

gsGive	tActionGive giveTable	; give item to npc
	tEnd

gsUse	tActionUse useTable	; use item
	tEnd

gsPickUp			; pick up item
	tActionPickUp
	tEnd

gsAffect			; affect element
	tActionAffect
	tEnd

gsEquip	tSelectEquip		; equipment
	tEnd

gsCraft	tActionCraft		; craft
	tEnd

; == DATA

; DOOR id,map,x,y,dx,dy,map2,x2,y2,dir2,flag
; flag b0 : inactive, b1 = b0 (init)
doorTable
	DOOR 0,5,9,8,2,1,10,14,16,0,1		; door to hall (map 5)
	DOOR 1,10,14,19,2,1,5,9,7,2,1		; door from hall (map 10)
	DOOR 2,9,11,11,3,2,11,18,13,2,1		; hole to cave (1-side)

	DOOR 3,12,25,6,2,1,10,20,13,0,0		; ladder from cave to hall
	DOOR 4,10,20,16,2,1,12,25,5,2,0		; ladder from hall to cave

	DOOR 5,13,24,1,2,1,14,24,13,0,0		; to cave 1
	DOOR 6,14,24,16,2,1,13,24,0,2,0		; from cave 1

	DOOR 7,16,25,9,1,2,17,6,9,1,0		; door to right roof
	DOOR 8,17,5,10,1,2,16,23,8,3,0

	DOOR 9,16,4,9,1,2,18,26,9,3,0
	DOOR 10,18,28,10,1,2,16,5,8,1,0

	DOOR 11,20,13,7,2,1,7,14,3,2,0
	DOOR 12,7,13,4,3,1,20,13,4,0,0

	DOOR 13,21,18,12,2,2,22,12,11,0,0	; hole in bandit cave

	DOOR 14,15,20,4,2,1,23,16,15,0,1	; to monastery
	DOOR 15,23,16,18,2,1,15,20,3,2,0

	DOOR 16,36,8,6,2,1,35,12,9,dirSouth,0
	DOOR 17,35,12,10,2,1,36,8,3,dirNorth,0

	DOOR 18,39,25,8,2,1,40,14,14,dirNorth,0	; to troll house
	DOOR 19,40,14,17,2,1,39,25,7,dirSouth,0

	DOOR 20,1,6,10,2,1,41,15,12,dirNorth,1	; to old man house (1)
	DOOR 21,41,15,15,2,1,1,6,9,dirSouth,0

	DOOR 22,37,13,7,3,1,45,12,16,dirNorth,1	; inside tree (1)
	DOOR 23,45,11,19,4,1,37,13,6,dirSouth,0

	DOOR 24,41,22,13,2,1,43,21,11,dirSouth,0 ; house - crystal cave
	DOOR 25,43,21,12,2,1,41,22,10,dirNorth,0

	DOOR 26,23,17,4,2,1,50,15,16,dirUp,1	; door to demon (1)
	DOOR 27,50,15,19,2,1,23,17,3,dirDown,0

	db 255

; ITEM id,map,x,y,small,big.num,name.adr
itemTable
	ITEM 0,17,16,13,1,0,inam00	; fire stone
	ITEM 1,255,0,0,2,1,inam01	; bandit key
	ITEM 2,255,0,0,3,2,inam02	; spider web
	ITEM 3,255,0,0,20,25,inam03	; green crystal powder
	ITEM 4,255,0,0,22,26,inam04	; green crystal
	ITEM 5,255,0,0,17,27,inam05	; Viking saga
	ITEM 6,18,3,9,7,6,inam06	; mozaic pieces : firecat, golem, troll, wizard
;	ITEM 7,255,0,0,7,6,inam06	;		golem
;	ITEM 8,255,0,0,7,6,inam06	;		troll
;	ITEM 9,255,0,0,7,6,inam06	;		wizard
	ITEM 10,255,0,0,20,7,inam10	; crystal powder
	ITEM 11,255,0,0,8,8,inam11	; crystal
	ITEM 12,255,0,0,9,9,inam12	; berries
	ITEM 13,255,0,0,9,10,inam12
	ITEM 14,255,0,0,9,11,inam12
	ITEM 15,255,0,0,9,12,inam12
	ITEM 16,255,0,0,11,13,inam16	; small bridge
	ITEM 17,30,26,3,12,14,inam17	; handcuffs
	ITEM 18,255,0,0,13,15,inam18	; TNT stick
	ITEM 19,255,0,0,14,16,inam19	; soft stone
	ITEM 20,255,0,0,15,17,inam20	; hammer
	ITEM 21,255,0,0,9,3,inam21	; cave berry
	ITEM 22,255,0,0,16,18,inam22	; rope
	ITEM 23,255,0,0,17,21,inam23	; knighthood for dummies
	ITEM 24,255,0,0,18,22,inam24	; earphone
	ITEM 25,255,0,0,19,23,inam25	; stone key
	ITEM 26,255,0,0,21,24,inam26	; troll hand
	ITEM 27,255,0,0,2,1,inam27	; old man chest key
	ITEM 28,255,0,0,23,28,inam28	; horn helm
	ITEM 29,255,0,0,24,29,inam29	; alony
	db 255

inam00	db MSGIT00,0
inam01	db MSGIT01,0
inam02	db MSGIT02,0
inam03	db MSGIT03,0
inam04	db MSGIT04,0
inam05	db MSGIT05,0
inam06	db MSGIT06,0
inam10	db MSGIT10,0
inam11	db MSGIT11,0
inam12	db MSGIT12,0
inam16	db MSGIT16,0
inam17	db MSGIT17,0
inam18	db MSGIT18,0
inam19	db MSGIT19,0
inam20	db MSGIT20,0
inam21	db MSGIT21,0
inam22	db MSGIT22,0
inam23	db MSGIT23,0
inam24	db MSGIT24,0
inam25	db MSGIT25,0
inam26	db MSGIT26,0
inam27	db MSGIT27,0
inam28	db MSGIT28,0
inam29	db MSGIT29,0

; magic

; MAGIC id,flag,mp.cost,cast.script.adr,name.adr
; flag : b0 : learned
magicTable
	MAGIC 0,1,5,m00use,m00txt
	MAGIC 1,0,10,m01use,m01txt
	MAGIC 2,0,10,m02use,m02txt
	MAGIC 3,0,12,m03use,m03txt
	MAGIC 4,0,15,m04use,m04txt
	db 0xff

m00txt	db 2,0," MP: ",MSGMG00,0
m01txt	db 2,1," MP: ",MSGMG01,0
m02txt	db 2,2," MP: ",MSGMG02,0
m03txt	db 2,3," MP: ",MSGMG03,0
m04txt	db 2,4," MP: ",MSGMG04,0

m00use			; heal
	tBattleScript 0,bsMAG	; heal anim to hero
	tDelMP 0,5		; del 5 MP
	tRaiseHP 0,128		; add 50% HP
m00end	tWaitNPC 0		; wait animation end
	tBattleScript 0,bsIDL	; idle anim to hero
	tEnd

m01use				; fireball
	tSelectEnemy 255,m01ex
	tDelMP 0,10
	tMoveElem 110,255,40,40
	tMapAni 110,aniFBall
	tAttack 0,255,m01frc
;	tPlaySFX 1
	tWaitElem 110
m01end	tDelHP 255,255
	tCheckNPC 255,1,m00end
	tBattleScript 255,bsDTH
	tWaitNPC 255
	tJump m00end
m01ex	tSetBit 255
	tEnd

m01frc	db 0,0,40,0,0,0,0,0	; 40 fire damage

m02use				; stone skin : def +50% in 2 turns
	tBattleScript 0,bsMAG
	tDelMP 0,10
	tAddAffect 0,2
	tJump m00end

m03use				; lightning storm
	tSelectEnemy 255,m01ex
	tDelMP 0,12
	tMoveElem 111,255,40,40
	tMapAni 111,aniLGTN
;	tPlaySFX 2
	tWaitElem 111
	tAttack 0,255,m03frc
	tJump m01end

m03frc	db 0,0,10,0,35,0,0,0	; 10 fire, 35 lightning damage

m04use				; dark mass
	tSelectEnemy 255,m01ex
	tDelMP 0,15
	tMoveElem 112,255,40,40
	tMapAni 112,aniDark
	tWaitElem 112
	tAttack 0,255,m04frc
	tJump m01end

m04frc	db 0,0,0,0,0,0,40,0	; 40 dark damage

; potions
; POTION id,type,duration,use.script,afct.script,name.adr

potionTable
	POTION 0,p00use,p00name		; +25% HP
	POTION 1,p01use,p01name		; +20% MP
	POTION 2,p02use,p02name		; +25% attack
	POTION 3,p02use,p02name		; -25% damage
	db 0xff

p00name	db 1,0,32,MSGPT00,0
p01name	db 1,1,32,MSGPT01,0
p02name	db 1,2,32,MSGPT02,0
p03name	db 1,3,32,MSGPT03,0

p00use	tNpcAni 0,c00drink
	tRaiseHP 0,64
	tWaitNPC 0
	tEnd

p01use	tNpcAni 0,c00drink
	tRaiseMP 0,50
	tWaitNPC 0
	tEnd

p02use	tNpcAni 0,c00drink
	tAddAffect 0,0
	tWaitNPC 0
	tEnd

p03use	tNpcAni 0,c00drink
	tAddAffect 0,1
	tWaitNPC 0
	tEnd

; effects

effectTable
	EFFECT 0,fxATK1,6,eff00s	; +25% attack
	EFFECT 1,fxDEF1,5,eff01s	; +25% defence
	EFFECT 2,fxDEF1,3,eff02s	; -60% damage
	db 0xff

eff00s	tRaiseDamage 64
	tEnd

eff01s	tReduceDamage 64
	tEnd

eff02s	tReduceDamage 154
	tEnd

; craft
; db item1,item2,resIcon,<script.adr>	: item1 + item2 = resIcon, exec script on craft

craftTable
	CRAFT 12,12,4,csHealPotion
	CRAFT 13,13,5,csMagicPotion
	CRAFT 14,14,19,csAtkPotion
	CRAFT 15,15,20,csDefPotion
	db 0xff

csHealPotion
	tAddPotion 0
	tCraftClear
	tInfoText MSGAP00
	tEnd

csMagicPotion
	tAddPotion 1
	tCraftClear
	tInfoText MSGAP01
	tEnd

csAtkPotion
	tAddPotion 2
	tCraftClear
	tInfoText MSGAP02
	tEnd

csDefPotion
	tAddPotion 3
	tCraftClear
	tInfoText MSGAP03
	tEnd

; equipment

equipTable
	DBW eArmor,armrTab
	DBW eSword,swrdTab
	DBW eShield,shldTab
	DBW eAmulet,amltTab
	db 0xff

armrTab	db 0				; b0..2 = current equip num (0..7)
	db 0				; availability equip (b1..7, b0 is allways 1)
	dw arm00,arm01,arm02,arm03
	dw 0,0,0,0

arm00	EQUIP 51,0,0,0,an00,2		; iadr=2 shows % converted values
arm01	EQUIP 64,64,0,0,an01,2
arm02	EQUIP 16,16,240,16,an02,2
arm03	EQUIP 128,96,64,96,an03,2

an00	db MSGAR00,0
an01	db MSGAR01,0
an02	db MSGAR02,0
an03	db MSGAR03,0

swrdTab	db 0,0
	dw swr00,swr01,swr02,swr03
	dw swr04,0,0,0

swr00	EQUIP 30,0,0,0,sn00,1		; iadr=1 shows ABS values
swr01	EQUIP 50,0,0,0,sn01,1
swr02	EQUIP 66,0,0,10,sn02,1
swr03	EQUIP 35,10,10,10,sn03,1
swr04	EQUIP 50,0,10,0,sn04,1

sn00	db MSGSW00,0
sn01	db MSGSW01,0
sn02	db MSGSW02,0
sn03	db MSGSW03,0
sn04	db MSGSW04,0

shldTab	db 0,0
	dw sld00,sld01,sld02,sld03
	dw 0,0,0,0

sld00	EQUIP 128,0,0,0,hn00,2
sld01	EQUIP 64,200,0,0,hn01,2
sld02	EQUIP 32,32,32,200,hn02,2
sld03	EQUIP 152,64,128,64,hn03,2

hn00	db MSGSH00,0
hn01	db MSGSH01,0
hn02	db MSGSH02,0
hn03	db MSGSH03,0

amltTab	db 0,0
	dw aml00,aml01,aml02,aml03
	dw aml04,aml05,0,0

; amulets
; +0	type (HP/MP/ATK/DEF)
; +1	bonus value
; +2,3	active script
; +4,5	name adr
; +6,7	info adr

aml00	AMULET fxNONE,0,mn00,0
aml01	AMULET fxSTART,amscr01,mn01,ai01
aml02	AMULET fxATK1,amscr02,mn02,ai02
aml03	AMULET fxDEF1,amscr03,mn03,ai03
aml04	AMULET fxDEF1,amscr04,mn04,ai04
aml05	AMULET fxTURN,amscr05,mn05,ai05

mn00	db MSGAM00,0
mn01	db MSGAM01,0
mn02	db MSGAM02,0
mn03	db MSGAM03,0
mn04	db MSGAM04,0
mn05	db MSGAM05,0

ai01	db MSGAI01,0
ai02	db MSGAI02,0
ai03	db MSGAI03,0
ai04	db MSGAI04,0
ai05	db MSGAI05,0

amscr01	tRaiseMaxHP 0,64
	tEnd

amscr02	tRaiseDamage 39
	tEnd

amscr03	tReduceDamage 64
	tEnd

amscr04	tIfRndLess 205,ams04e
	tSetDamage 0
ams04e	tEnd

amscr05	tAddMP 0,1
	tEnd

; tilesets

tileSetTable
	dw tmAdrs,caveTiles,btl00Tiles,treeTiles
	dw finalTiles

tmAdrs	dw 0
	dw tile100	; bg
	dw tile200	; impassable
	dw tile300	; items		[mask]
	dw tile400	; npc		[mask]
	dw tile500	; player	[mask]
	dw tile600	; top		[mask]
	dw tile700	; tables

caveTiles
	dw 0,tile100,tile20c,tile300,tile400,tile500,tile600,tile700
treeTiles
	dw 0,tile100,tile20t,tile300,tile400,tile500,tile600,tile700
btl00Tiles
	dw 0,tile100,tile200,tile300,firecatTiles,tile500,tile600,tile700
finalTiles
	dw 0,tile100,tile200,tile300,demonTiles,tile500,tile600,tile700

	include "talk.asm"
	include "give.asm"
	include "use.asm"
	include "npcs.asm"
	include "elems.asm"
	include "zones.asm"
	include "battles.asm"
