	DEVICE ZXSPECTRUM128

	MACRO dbw p1,p2
	 db p1
	 dw p2
	ENDM
	
	org 0x8000,0
	
start	ei
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x1800
	ld (hl),l
	ldir
	ld bc,767
	ld (hl),7
	ldir
	xor a
	out (254),a
	call noIntro
	call powered
	call waiter
intr06	call atrCls
	ld hl,0x5800
	ld de,0x5801
	ld bc,0x2ff
	ld (hl),l
	ldir
	halt
	ld hl,sword
	ld de,0x4000
	ld bc,0x1800
	ldir
	halt
	ld bc,0x300
	ldir
	ret

waiter	ld b,250
	ei
	call noKey
intr05	halt
	xor a
	in a,(254)
	cpl
	and 31
	ret nz
	djnz intr05
	ret
	
atrCls	ld b,8
acls0	halt
	ld hl,0x5800
acls1	ld c,(hl)
	ld a,c
	and 0x38
	jr z,acls2
	ld a,c
	sub 8
	ld c,a
acls2	ld a,c
	and 7
	jr z,acls3
	dec c
acls3	ld (hl),c
	inc hl
	ld a,h
	cp 0x5b
	jr c,acls1
	djnz acls0
	ld hl,0x4000
	ld de,0x4001
	ld bc,0x17ff
	ld (hl),l
	ldir
	ret
	
testKey	xor a
	in a,(0xfe)
	cpl
	and 31
	ret
	
noKey	call testKey
	jr nz,noKey
	ret

introTxt
	dbw 1,0x488d
	db "INTRO?"
	db 2,100
	dbw 3,0x4881
	dbw 1,0x4884
	db "THERE IS NO INTRO HERE!"
	db 2,100
	dbw 3,0x4881
	dbw 1,0x4886
	db "D'YA WAIT FOR A CAT?"
	db 2,100
	dbw 3,0x4884
	dbw 1,0x4830
	db "ENJOY!"
	dbw 1,0x488d
	db "AND TRY TO"
	dbw 1,0x48cc
	db "FIND ANY KEY"
	db 0

noIntro	ld hl,0x5900
	ld a,0x4f
nint1	ld (hl),a
	inc l
	jr nz,nint1
	ld hl,introTxt
nint2	and a
	ret c
	ld a,(hl)
	and a
	jr z,nintEnd
	inc hl
	sub 32
	jr c,nintCom
	call print
	call testKey
	ret nz
	jr nint2
nintCom	push hl
	ld hl,nint2
	ex (sp),hl
	push hl
	ld hl,nComTab
	and 31
	add a,a
	add a,l
	ld l,a
	adc a,h
	sub l
	ld h,a
	ld a,(hl)
	inc hl
	ld h,(hl)
	ld l,a
	ex (sp),hl
void	ret
nintEnd	ld hl,aniCat
	ld de,0x4800
	call INITANI
ninte1	halt
	call PLAYANI
	xor a
	in a,(254)
	cpl
	and 31
	jr z,ninte1
	ret

nComTab	dw void,nc01,nc02,nc03
	dw void,void,void,void
	dw void,void,void,void
	dw void,void,void,void
	dw void,void,void,void
	dw void,void,void,void
	dw void,void,void,void
	dw void,void,void,void

nc01	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ret
	
nc02	ld b,(hl)
	inc hl
nc02a	halt
	call testKey
	jr nz,nc02e
	djnz nc02a
	ret
nc03e	pop hl
nc02e	ld a,0x37
	ld (nint2),a
	ret

nc03	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	push hl
	ex de,hl
	ld d,h
nc03z	ld b,8
nc03x	halt
	call testKey
	jr nz,nc03e
nc03a	and a
	rr (hl)
	inc h
	ld a,h
	and 7
	jr nz,nc03a
	ld h,d
	djnz nc03x
	inc l
	ld a,l
	and 31
	jr nz,nc03z
	pop hl
	ret

print	push hl
	ld l,a
	ld h,0
	ld bc,font
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,8
	ld c,d
prn1	ld a,(hl)
	ld (de),a
	inc hl
	inc d
	djnz prn1
	ld d,c
	pop hl
	inc e
	ret

powered	call atrCls
	ld hl,powSpr
	ld de,0x40ec
	ld b,0
	ld a,9
intr01	exa
intr02	ld a,e
	ld c,7
	ldir
	ld e,a
	inc d
	ld a,d
	and 7
	jr nz,intr02
	ld a,e
	add a,32
	ld e,a
	jr c,intr03
	ld a,d
	sub 8
	ld d,a
intr03	exa
	dec a
	jr nz,intr01
	ld de,0x58ec
	ld a,9
intr04	exa
	ld bc,7
	ldir
	ld a,e
	add a,25
	ld e,a
	adc a,d
	sub e
	ld d,a
	exa
	dec a
	jr nz,intr04
	ret

	include "aniplay.asm"

sword	incbin "sword.scr"
powSpr	incbin "pow7x9.bin"
font	incbin "font x1.bin"
aniCat	incbin "cat2.ani"
	
	SAVEBIN "intro.bin",start,$-start
	SAVESNA "intro.sna",start